/*****************************************************************************
  H8/3069pI2CCuwb_[t@C(I2C.H)
  
  H8/3069pI2CCułB|[ggpI2C̃}X^s܂B
  ̃}X^ɂ͑ΉĂ܂BI2CC^tF[XEEPROMp֐܂
  ł܂B
  
  Copyright (C) eNmEF[u 2007
*****************************************************************************/
#ifndef __I2C_H__
#define __I2C_H__

#include"types.h"

//RfBVrbg\萔
#define I2C_START 0x01
#define I2C_STOP  0x02

//G[R[h
#define I2CS_TIMEOUT 0x00010000 //SCL̉҂Ń^CAEgꍇ
#define I2CS_NACK    0x00020000 //NACKMꍇ

void I2C_SetPort(DWORD Port, int SclBit, int SdaBit, BYTE DDR);
void I2C_SetWait(BYTE Wait);
DWORD I2C_Read(BYTE SlaveAddr, void *pData, WORD nData, WORD Condition);
DWORD I2C_Write(BYTE SlaveAddr, void *pData, WORD nData, WORD Condition);
WORD EE24_Write(BYTE SlaveAddr, DWORD Addr, void *pData, WORD nData, WORD nAddrBits);
WORD EE24_Read(BYTE SlaveAddr, DWORD Addr, void *pData, WORD nData, WORD nAddrBits);

#endif /*__I2C_H__*/

/*****************************************************************************
  void I2C_SetPort(DWORD Port, int SclBit, int SdaBit, BYTE DDR)
  
  Port   : gp|[gDRAhX
  SclBit : SCLƂĎgprbg̔ԍ(0-7)
  SdaBit : SDAƂĎgprbg̔ԍ(0-7)
  DDR    : gpDDR̋Kl
  
  I2CC^tF[XƂĎgp|[gݒ肵܂BDDR͎gp|[g
  DDR(rbg̓o͕𑀍삷郌WX^)ɐݒ肷l^܂BI2Cł͏o
  I[vRN^ƂȂĂ邽ߎgp|[gDDR𑀍삵܂BA
  DDR̓rbgłȂ̂ŁASẴrbgĂ܂AI2CŎgp
  Ȃrbg㏑Ă܂܂B̂߁ÃCułI2CŎgp
  Ȃrbg̏Ԃۑ邽߂ɗ\DDR̒lL^ĂÃrbgɂ
  ̒lނ悤ɂĂ܂B
*****************************************************************************/

/*****************************************************************************
  void I2C_SetWait(BYTE Wait)
  
  Wait : [h/Cg̃EFCgݒ
  
  I2C̓]x𐧌䂵܂B
  Wait̒l̓t@[Xg[h(400KHzȉ)̏ꍇ0ȏAX^_[h[h(100KHz
  ȉ)̏ꍇ14ȏƂĂB
*****************************************************************************/

/*****************************************************************************
  DWORD I2C_Write(BYTE SlaveAddr, void *pData, WORD nData, WORD Condition)
  
  SlaveAddr : X[uAhX
  pData     : [in]ރf[^
  nData     : ރf[^̃oCg
  Condition : MOɃX^[gRfBVAXgbvRfBVo
              邩ǂw肵܂BȉORŌ܂B
              I2C_START(0x01) MOɃX^[gRfBVo͂܂B
              I2C_STOP(0x02)  MɃXgbvRfBVo͂܂B
  
  ߂l    : 16rbgG[Xe[^XA16rbgMoCg
              G[͉L̒lɂȂ܂
              I2CS_TIMEOUT(0x010000) SCL̉҂Ń^CAEg
              I2CS_NACK(0x020000)    ACKԂȂ
              
  I2CC^tF[Xʂăf[^݂܂BX[uAhX̓X^[gR
  fBVo͂ꍇ̂ݑM܂BX[uAhXMSBl߂
  ͂܂BLSB͎R/WZbg܂B
*****************************************************************************/

/*****************************************************************************
  DWORD I2C_Read(BYTE SlaveAddr, void *pData, WORD nData, WORD Condition)
  
  SlaveAddr : X[ufoCX̃AhX
  pData     : [out]ǂݏof[^̊i[
  nData     : ǂݏof[^̃oCg
  Condition : MOɃX^[gRfBVAXgbvRfBVo
              邩ǂw肵܂BȉORŌ܂B
              I2C_START(0x01) MOɃX^[gRfBVo͂܂B
              I2C_STOP(0x02)  MɃXgbvRfBVo͂܂B
  
  ߂l    : 16rbgG[Xe[^XA16rbgMoCg
              G[͉L̒lɂȂ܂
              I2CS_TIMEOUT(0x010000) SCL̉҂Ń^CAEg
              I2CS_NACK(0x020000)    ACKԂȂ
              
  I2CC^tF[Xf[^ǂ݂܂BX[uAhX̓X^[gRfBV
  o͂ꍇ̂ݑM܂BX[uAhXMSBl߂ē͂
  BLSB͖܂BXgbvRfBVo͂ꍇ͓Ǐo̍ŏIo
  CgɂACKԂ܂B
*****************************************************************************/

/*****************************************************************************
  WORD EE24_Write(BYTE SlaveAddr, DWORD Addr,
                  void *pData, WORD nData, WORD nAddrBits)
  
  SlaveAddr : X[uAhXB
  Addr      : ANZX郁AhX
  pData     : [in]ރf[^
  nData     : ރf[^̃oCg
  nAddrBits : foCX̃AhXrbg

  ߂l    : ݂łoCg

  I2CEEPROMɏ݂s܂BX[uAhXMSBl߂ē͂܂B
  EEPROMɃANZXꍇ͏4rbgB'1010Ƃ܂BLSB͎IR/WZb
  g܂BAhXrbg9,10,11,17̃foCXɂĂ͎IɃAhX
  ̏ʃrbgX[uAhXɊi[܂B
*****************************************************************************/

/*****************************************************************************
  WORD EE24_Read(BYTE SlaveAddr, DWORD Addr, 
                 void *pData, WORD nData, WORD nAddrBits)
  
  SlaveAddr : X[uAhXB
  Addr      : ANZX郁AhX
  pData     : [out]ǂݏof[^
  nData     : ǂݏof[^̃oCg
  nAddrBits : foCX̃AhXrbg

  ߂l    : ǂݏooCg

  I2CEEPROMǂݏo܂BX[uAhXMSBl߂ē͂܂B
  EEPROMɃANZXꍇ͏4rbgB'1010Ƃ܂BLSB͎IR/WZb
  g܂B
  AhXrbg9,10,11,17̃foCXɂĂ͎IɃAhX̏ʃrbg
  X[uAhXɊi[܂B
*****************************************************************************/