/*****************************************************************************
  h8ios.h

  WX^`t@C

  eNmEF[u 2007
*****************************************************************************/
#ifndef _H8IOS_H_
#define _H8IOS_H_

//|[gfBNV
#define P1DDR (*((volatile unsigned char *)0xfee000))
#define P2DDR (*((volatile unsigned char *)0xfee001))
#define P3DDR (*((volatile unsigned char *)0xfee002))
#define P4DDR (*((volatile unsigned char *)0xfee003))
#define P5DDR (*((volatile unsigned char *)0xfee004))
#define P6DDR (*((volatile unsigned char *)0xfee005))

#define P8DDR (*((volatile unsigned char *)0xfee007))
#define P9DDR (*((volatile unsigned char *)0xfee008))
#define PADDR (*((volatile unsigned char *)0xfee009))
#define PBDDR (*((volatile unsigned char *)0xfee00a))

//|[gf[^
#define P1DR (*((volatile unsigned char *)0xffffd0))
#define P2DR (*((volatile unsigned char *)0xffffd1))
#define P3DR (*((volatile unsigned char *)0xffffd2))
#define P4DR (*((volatile unsigned char *)0xffffd3))
#define P5DR (*((volatile unsigned char *)0xffffd4))
#define P6DR (*((volatile unsigned char *)0xffffd5))
#define P7DR (*((volatile unsigned char *)0xffffd6))
#define P8DR (*((volatile unsigned char *)0xffffd7))
#define P9DR (*((volatile unsigned char *)0xffffd8))
#define PADR (*((volatile unsigned char *)0xffffd9))
#define PBDR (*((volatile unsigned char *)0xffffda))

//vAbv
#define P2PCR (*((volatile unsigned char *)0xfee03c))
#define P4PCR (*((volatile unsigned char *)0xfee03e))
#define P5PCR (*((volatile unsigned char *)0xfee03f))

//VXe
#define MDCR (*((volatile unsigned char *)0xfee011))
#define SYSCR (*((volatile unsigned char *)0xfee012))

#define DIVCR (*((volatile unsigned char *)0xfee01b))
#define MSTCRH (*((volatile unsigned char *)0xfee01c))
#define MSTCRL (*((volatile unsigned char *)0xfee01d))


//oXRg[
#define BRCR (*((volatile unsigned char *)0xfee013))

//荞݃Rg[
#define ISCR (*((volatile unsigned char *)0xfee014))
#define IER (*((volatile unsigned char *)0xfee015))
#define ISR (*((volatile unsigned char *)0xfee016))
#define IPRA (*((volatile unsigned char *)0xfee018))
#define IPRB (*((volatile unsigned char *)0xfee019))

//oXRg[
#define ADRCR (*((volatile unsigned char *)0xfee01e))
#define CSCR (*((volatile unsigned char *)0xfee01f))
#define ABWCR (*((volatile unsigned char *)0xfee020))
#define ASTCR (*((volatile unsigned char *)0xfee021))
#define WCRH (*((volatile unsigned char *)0xfee022))
#define WCRL (*((volatile unsigned char *)0xfee023))
#define BCR (*((volatile unsigned char *)0xfee024))

//16rbg^C}
#define TSTR (*((volatile unsigned char *)0xffff60))
#define TSNC (*((volatile unsigned char *)0xffff61))
#define TMDR (*((volatile unsigned char *)0xffff62))
#define TOLR (*((volatile unsigned char *)0xffff63))
#define TISRA (*((volatile unsigned char *)0xffff64))
#define TISRB (*((volatile unsigned char *)0xffff65))
#define TISRC (*((volatile unsigned char *)0xffff66))

#define TCR0_16 (*((volatile unsigned char *)0xffff68))
#define TIOR0 (*((volatile unsigned char *)0xffff69))
#define TCNT0H_16 (*((volatile unsigned char *)0xffff6A))
#define TCNT0L_16 (*((volatile unsigned char *)0xffff6B))
#define GRA0H (*((volatile unsigned char *)0xffff6C))
#define GRA0L (*((volatile unsigned char *)0xffff6D))
#define GRB0H (*((volatile unsigned char *)0xffff6E))
#define GRB0L (*((volatile unsigned char *)0xffff6F))

#define TCNT0_16 (*((volatile unsigned short *)0xffff6A))
#define GRA0 (*((volatile unsigned short *)0xffff6C))
#define GRB0 (*((volatile unsigned short *)0xffff6E))

#define TCR1_16 (*((volatile unsigned char *)0xffff70))
#define TIOR1 (*((volatile unsigned char *)0xffff71))
#define TCNT1H_16 (*((volatile unsigned char *)0xffff72))
#define TCNT1L_16 (*((volatile unsigned char *)0xffff73))
#define GRA1H (*((volatile unsigned char *)0xffff74))
#define GRA1L (*((volatile unsigned char *)0xffff75))
#define GRB1H (*((volatile unsigned char *)0xffff76))
#define GRB1L (*((volatile unsigned char *)0xffff77))

#define TCNT1_16 (*((volatile unsigned short *)0xffff72))
#define GRA1 (*((volatile unsigned short *)0xffff74))
#define GRB1 (*((volatile unsigned short *)0xffff76))

#define TCR2_16 (*((volatile unsigned char *)0xffff78))
#define TIOR2 (*((volatile unsigned char *)0xffff79))
#define TCNT2H_16 (*((volatile unsigned char *)0xffff7A))
#define TCNT2L_16 (*((volatile unsigned char *)0xffff7B))
#define GRA2H (*((volatile unsigned char *)0xffff7C))
#define GRA2L (*((volatile unsigned char *)0xffff7D))
#define GRB2H (*((volatile unsigned char *)0xffff7E))
#define GRB2L (*((volatile unsigned char *)0xffff7F))

#define TCNT2_16 (*((volatile unsigned short *)0xffff7A))
#define GRA2 (*((volatile unsigned short *)0xffff7C))
#define GRB2 (*((volatile unsigned short *)0xffff7E))

//8rbg^C}
#define TCR0_8 (*((volatile unsigned char *)0xffff80))
#define TCSR0_8 (*((volatile unsigned char *)0xffff82))
#define TCORA0 (*((volatile unsigned char *)0xffff84))
#define TCORB0 (*((volatile unsigned char *)0xffff86))
#define TCNT0_8 (*((volatile unsigned char *)0xffff88))

#define TCR1_8 (*((volatile unsigned char *)0xffff81))
#define TCSR1_8 (*((volatile unsigned char *)0xffff83))
#define TCORA1 (*((volatile unsigned char *)0xffff85))
#define TCORB1 (*((volatile unsigned char *)0xffff87))
#define TCNT1_8 (*((volatile unsigned char *)0xffff89))

#define TCR2_8 (*((volatile unsigned char *)0xffff90))
#define TCSR2_8 (*((volatile unsigned char *)0xffff92))
#define TCORA2 (*((volatile unsigned char *)0xffff94))
#define TCORB2 (*((volatile unsigned char *)0xffff96))
#define TCNT2_8 (*((volatile unsigned char *)0xffff98))

#define TCR3_8 (*((volatile unsigned char *)0xffff91))
#define TCSR3_8 (*((volatile unsigned char *)0xffff93))
#define TCORA3 (*((volatile unsigned char *)0xffff95))
#define TCORB3 (*((volatile unsigned char *)0xffff97))
#define TCNT3_8 (*((volatile unsigned char *)0xffff99))

//DMARg[
#define MAR0A (*((volatile unsigned long *)0xffff20))
#define MAR0AR (*((volatile unsigned char *)0xffff20))
#define MAR0AE (*((volatile unsigned char *)0xffff21))
#define MAR0AH (*((volatile unsigned char *)0xffff22))
#define MAR0AL (*((volatile unsigned char *)0xffff23))
#define ETCR0A (*((volatile unsigned short *)0xffff24))
#define ETCR0AH (*((volatile unsigned char *)0xffff24))
#define ETCR0AL (*((volatile unsigned char *)0xffff25))
#define IOAR0A (*((volatile unsigned char *)0xffff26))
#define DTCR0A (*((volatile unsigned char *)0xffff27))

#define MAR0B (*((volatile unsigned long *)0xffff28))
#define MAR0BR (*((volatile unsigned char *)0xffff28))
#define MAR0BE (*((volatile unsigned char *)0xffff29))
#define MAR0BH (*((volatile unsigned char *)0xffff2a))
#define MAR0BL (*((volatile unsigned char *)0xffff2b))
#define ETCR0B (*((volatile unsigned short *)0xffff2c))
#define ETCR0BH (*((volatile unsigned char *)0xffff2c))
#define ETCR0BL (*((volatile unsigned char *)0xffff2d))
#define IOAR0B (*((volatile unsigned char *)0xffff2e))
#define DTCR0B (*((volatile unsigned char *)0xffff2f))

#define MAR1A (*((volatile unsigned long *)0xffff30))
#define MAR1AR (*((volatile unsigned char *)0xffff30))
#define MAR1AE (*((volatile unsigned char *)0xffff31))
#define MAR1AH (*((volatile unsigned char *)0xffff32))
#define MAR1AL (*((volatile unsigned char *)0xffff33))
#define ETCR1A (*((volatile unsigned short *)0xffff34))
#define ETCR1AH (*((volatile unsigned char *)0xffff34))
#define ETCR1AL (*((volatile unsigned char *)0xffff35))
#define IOAR1A (*((volatile unsigned char *)0xffff36))
#define DTCR1A (*((volatile unsigned char *)0xffff37))

#define MAR1B (*((volatile unsigned long *)0xffff38))
#define MAR1BR (*((volatile unsigned char *)0xffff38))
#define MAR1BE (*((volatile unsigned char *)0xffff39))
#define MAR1BH (*((volatile unsigned char *)0xffff3a))
#define MAR1BL (*((volatile unsigned char *)0xffff3b))
#define ETCR1B (*((volatile unsigned short *)0xffff3c))
#define ETCR1BH (*((volatile unsigned char *)0xffff3c))
#define ETCR1BL (*((volatile unsigned char *)0xffff3d))
#define IOAR1B (*((volatile unsigned char *)0xffff3e))
#define DTCR1B (*((volatile unsigned char *)0xffff3f))


//ADRo[^
#define ADDRAH (*((volatile unsigned char *)0xffffe0))
#define ADDRAL (*((volatile unsigned char *)0xffffe1))
#define ADDRBH (*((volatile unsigned char *)0xffffe2))
#define ADDRBL (*((volatile unsigned char *)0xffffe3))
#define ADDRCH (*((volatile unsigned char *)0xffffe4))
#define ADDRCL (*((volatile unsigned char *)0xffffe5))
#define ADDRDH (*((volatile unsigned char *)0xffffe6))
#define ADDRDL (*((volatile unsigned char *)0xffffe7))
#define ADCSR (*((volatile unsigned char *)0xffffe8))
#define ADCR (*((volatile unsigned char *)0xffffe9))

#define ADDRA (*((volatile unsigned short *)0xffffe0))
#define ADDRB (*((volatile unsigned short *)0xffffe2))
#define ADDRC (*((volatile unsigned short *)0xffffe4))
#define ADDRD (*((volatile unsigned short *)0xffffe6))

//DARo[^
#define DADR0 (*((volatile unsigned char *)0xffff9c))
#define DADR1 (*((volatile unsigned char *)0xffff9d))
#define DACR (*((volatile unsigned char *)0xffff9e))

//SCI
#define SMR0 (*((volatile unsigned char *)0xffffb0))
#define BRR0 (*((volatile unsigned char *)0xffffb1))
#define SCR0 (*((volatile unsigned char *)0xffffb2))
#define TDR0 (*((volatile unsigned char *)0xffffb3))
#define SSR0 (*((volatile unsigned char *)0xffffb4))
#define RDR0 (*((volatile unsigned char *)0xffffb5))
#define SCMR0 (*((volatile unsigned char *)0xffffb6))


//CCAZup
static void _H8IOS_ASM( void )
{
  //|[gfBNV
  _asm P1DDR    EQU H'00fee000
  _asm P2DDR    EQU H'00fee001
  _asm P3DDR    EQU H'00fee002
  _asm P4DDR    EQU H'00fee003
  _asm P5DDR    EQU H'00fee004
  _asm P6DDR    EQU H'00fee005

  _asm P8DDR    EQU H'00fee007
  _asm P9DDR    EQU H'00fee008
  _asm PADDR    EQU H'00fee009
  _asm PBDDR    EQU H'00fee00a

  //|[gf[^
  _asm P1DR   EQU H'00ffffd0
  _asm P2DR   EQU H'00ffffd1
  _asm P3DR   EQU H'00ffffd2
  _asm P4DR   EQU H'00ffffd3
  _asm P5DR   EQU H'00ffffd4
  _asm P6DR   EQU H'00ffffd5
  _asm P7DR   EQU H'00ffffd6
  _asm P8DR   EQU H'00ffffd7
  _asm P9DR   EQU H'00ffffd8
  _asm PADR   EQU H'00ffffd9
  _asm PBDR   EQU H'00ffffda

  //vAbv
  _asm P2PCR    EQU H'00fee03c
  _asm P4PCR    EQU H'00fee03e
  _asm P5PCR    EQU H'00fee03f

  //VXe
  _asm MDCR   EQU H'00fee011
  _asm SYSCR    EQU H'00fee012

  _asm DIVCR    EQU H'00fee01b
  _asm MSTCRH   EQU H'00fee01c
  _asm MSTCRL   EQU H'00fee01d

  //oXRg[
  _asm BRCR     EQU H'00fee013

  //荞݃Rg[
  _asm ISCR   EQU H'00fee014
  _asm IER    EQU H'00fee015
  _asm ISR    EQU H'00fee016
  _asm IPRA   EQU H'00fee018
  _asm IPRB   EQU H'00fee019

  //oXRg[
  _asm ADRCR    EQU H'00fee01e
  _asm CSCR   EQU H'00fee01f
  _asm ABWCR    EQU H'00fee020
  _asm ASTCR    EQU H'00fee021
  _asm WCRH   EQU H'00fee022
  _asm WCRL   EQU H'00fee023
  _asm BCR    EQU H'00fee024

  //16rbg^C}
  _asm TSTR   EQU H'00ffff60
  _asm TSNC   EQU H'00ffff61
  _asm TMDR   EQU H'00ffff62
  _asm TOLR   EQU H'00ffff63
  _asm TISRA    EQU H'00ffff64
  _asm TISRB    EQU H'00ffff65
  _asm TISRC    EQU H'00ffff66

  _asm TCR0_16  EQU H'00ffff68
  _asm TIOR0    EQU H'00ffff69
  _asm TCNT0H_16  EQU H'00ffff6A
  _asm TCNT0L_16  EQU H'00ffff6B
  _asm GRA0H    EQU H'00ffff6C
  _asm GRA0L    EQU H'00ffff6D
  _asm GRB0H    EQU H'00ffff6E
  _asm GRB0L    EQU H'00ffff6F

  _asm TCNT0_16 EQU H'00ffff6A
  _asm GRA0   EQU H'00ffff6C
  _asm GRB0   EQU H'00ffff6E

  _asm TCR1_16  EQU H'00ffff70
  _asm TIOR1    EQU H'00ffff71
  _asm TCNT1H_16  EQU H'00ffff72
  _asm TCNT1L_16  EQU H'00ffff73
  _asm GRA1H    EQU H'00ffff74
  _asm GRA1L    EQU H'00ffff75
  _asm GRB1H    EQU H'00ffff76
  _asm GRB1L    EQU H'00ffff77

  _asm TCNT1_16 EQU H'00ffff72
  _asm GRA1   EQU H'00ffff74
  _asm GRB1   EQU H'00ffff76

  _asm TCR2_16  EQU H'00ffff78
  _asm TIOR2    EQU H'00ffff79
  _asm TCNT2H_16  EQU H'00ffff7A
  _asm TCNT2L_16  EQU H'00ffff7B
  _asm GRA2H    EQU H'00ffff7C
  _asm GRA2L    EQU H'00ffff7D
  _asm GRB2H    EQU H'00ffff7E
  _asm GRB2L    EQU H'00ffff7F

  _asm TCNT2_16 EQU H'00ffff7A
  _asm GRA2   EQU H'00ffff7C
  _asm GRB2   EQU H'00ffff7E

  //8rbg^C}
  _asm TCR0_8   EQU H'00ffff80
  _asm TCSR0_8  EQU H'00ffff82
  _asm TCORA0   EQU H'00ffff84
  _asm TCORB0   EQU H'00ffff86
  _asm TCNT0_8  EQU H'00ffff88

  _asm TCR1_8   EQU H'00ffff81
  _asm TCSR1_8  EQU H'00ffff83
  _asm TCORA1   EQU H'00ffff85
  _asm TCORB1   EQU H'00ffff87
  _asm TCNT1_8  EQU H'00ffff89

  _asm TCR2_8   EQU H'00ffff90
  _asm TCSR2_8  EQU H'00ffff92
  _asm TCORA2   EQU H'00ffff94
  _asm TCORB2   EQU H'00ffff96
  _asm TCNT2_8  EQU H'00ffff98

  _asm TCR3_8   EQU H'00ffff91
  _asm TCSR3_8  EQU H'00ffff93
  _asm TCORA3   EQU H'00ffff95
  _asm TCORB3   EQU H'00ffff97
  _asm TCNT3_8  EQU H'00ffff99

  //DMARg[
  _asm MAR0A    EQU H'00ffff20
  _asm MAR0AR   EQU H'00ffff20
  _asm MAR0AE   EQU H'00ffff21
  _asm MAR0AH   EQU H'00ffff22
  _asm MAR0AL   EQU H'00ffff23
  _asm ETCR0A   EQU H'00ffff24
  _asm ETCR0AH  EQU H'00ffff24
  _asm ETCR0AL  EQU H'00ffff25
  _asm IOAR0A   EQU H'00ffff26
  _asm DTCR0A   EQU H'00ffff27

  _asm MAR0B    EQU H'00ffff28
  _asm MAR0BR   EQU H'00ffff28
  _asm MAR0BE   EQU H'00ffff29
  _asm MAR0BH   EQU H'00ffff2a
  _asm MAR0BL   EQU H'00ffff2b
  _asm ETCR0B   EQU H'00ffff2c
  _asm ETCR0BH  EQU H'00ffff2c
  _asm ETCR0BL  EQU H'00ffff2d
  _asm IOAR0B   EQU H'00ffff2e
  _asm DTCR0B   EQU H'00ffff2f

  _asm MAR1A    EQU H'00ffff30
  _asm ETCR1A   EQU H'00ffff34
  _asm ETCR1AH  EQU H'00ffff34
  _asm ETCR1AL  EQU H'00ffff35
  _asm IOAR1A   EQU H'00ffff36
  _asm DTCR1A   EQU H'00ffff37

  _asm MAR1B    EQU H'00ffff38
  _asm ETCR1B   EQU H'00ffff3c
  _asm ETCR1BH  EQU H'00ffff3c
  _asm ETCR1BL  EQU H'00ffff3d
  _asm IOAR1B   EQU H'00ffff3e
  _asm DTCR1B   EQU H'00ffff3f

  //ADRo[^
  _asm ADDRAH   EQU H'00ffffe0
  _asm ADDRAL   EQU H'00ffffe1
  _asm ADDRBH   EQU H'00ffffe2
  _asm ADDRBL   EQU H'00ffffe3
  _asm ADDRCH   EQU H'00ffffe4
  _asm ADDRCL   EQU H'00ffffe5
  _asm ADDRDH   EQU H'00ffffe6
  _asm ADDRDL   EQU H'00ffffe7
  _asm ADCSR    EQU H'00ffffe8
  _asm ADCR   EQU H'00ffffe9

  _asm ADDRA    EQU H'00ffffe0
  _asm ADDRB    EQU H'00ffffe2
  _asm ADDRC    EQU H'00ffffe4
  _asm ADDRD    EQU H'00ffffe6

  //DARo[^
  _asm DADR0    EQU H'00ffff9c
  _asm DADR1    EQU H'00ffff9d
  _asm DACR   EQU H'00ffff9e

  //SCI
  _asm SMR0   EQU H'00ffffb0
  _asm BRR0   EQU H'00ffffb1
  _asm SCR0   EQU H'00ffffb2
  _asm TDR0   EQU H'00ffffb3
  _asm SSR0   EQU H'00ffffb4
  _asm RDR0   EQU H'00ffffb5
  _asm SCMR0    EQU H'00ffffb6
}

#endif //_H8IOS_H_
