/*****************************************************************************
  SPIpCuwb_[t@C(SPI.H)
  
  H8/3069pSPIpCułB|[ggpSPĨ}X^s܂
  SPIMicrowireC^tF[XEEPROMp֐܂ł܂B
  
  Copyright (C) eNmEF[u 2007
*****************************************************************************/
#ifndef __SPI_H__
#define __SPI_H__

#include "types.h"

void SPI_SetPort(DWORD Port, int CLKBit, int DOBit, int DIBit, DWORD CSPort, BYTE CSBits);
void SPI_SetWait(WORD Wait);
void SPI_WriteRead(void *pWrite, WORD nWriteBits, void *pRead, WORD nReadBits, BYTE Mode);
void SPI_Write(void *pWrite, WORD nWriteBits, BYTE Mode);
void SPI_Read(void *pRead, WORD nReadBits, BYTE Mode);

BYTE EE25_ReadStatus();
void EE25_WriteStatus(BYTE Status);
void EE25_WriteEnable(BOOL flgEnable);
void EE25_Write(DWORD Address, void *pData, WORD nWrite, int nAddressBits);
void EE25_Read(DWORD Address, void *pData, WORD nRead, int nAddressBits);

void EE93_WriteEnable(BOOL flgEnable, int nAddressBits);
void EE93_EraseAll(int nAddressBits);
void EE93_WriteAll(WORD Data, int nAddressBits);
void EE93_Write(DWORD Address, void *pData, WORD nDataWords, int nAddressBits);
void EE93_Read(DWORD Address, void *pData, WORD nDataWords, int nAddressBits);
BOOL EE93_IsReady();

#endif

/*****************************************************************************
  void SPI_SetPort(DWORD Port, int CLKBit, int DOBit, int DIBit, 
                   DWORD CSPort, BYTE CSBits)
  
  Port   : CLK,DO,DI[qƂĎgp|[gAhX
  CLKBit : CLKɎgprbgԍ(0`7)
  DOBit  : DOɎgprbgԍ(0`7)
  DIBit  : DIɎgprbgԍ(0`7)
  CSPort : CSɎgp|[gAhX
  CSBits : CSɎgprbg(rbg}bvŎw)
  
  SPIC^tF[XɎgp|[gw肵܂BCSɎgp|[g͑̃rb
  gƕʂɎwł܂BCSBitŝݔԍł͂Ȃrbg}bvŎw肷邱Ƃɒ
  ĂBႦ΃rbg7gpꍇ̐ݒl0x80łBCSBits͕w
  \ł̂ŕfoCXւ݂̓Ȃǂ\łiǂݏo͓ɂ
  ł܂jBANZXOCS̑ȂꍇACSPort,CSBitsƂ0ƂĂ
  B
*****************************************************************************/

/*****************************************************************************
  void SPI_SetWait(BYTE Mode, WORD Wait)
  
  Wait : EFCgp[^
  
  EFCgݒ肵܂BEFCgp[^1閈ɖ480nsNbNTC
  NLт܂B
*****************************************************************************/

/*****************************************************************************
  void SPI_WriteRead(void *pWrite, WORD nWriteBits,
                     void *pRead, WORD nReadBits, BYTE Mode)
  
  pWrite     : [in]݃f[^
  nWriteBits : ݃rbg
  pRead      : [out]ǂݏof[^̊i[
  nReadBits  : ǂݏorbg
  Mode       : 샂[h
               rbg0 ǏoNbNʑ(CPHA)
               rbg1 ݎNbNʑ(CPHA)
               rbg2 NbNɐ(CPOL)
               rbg3 f[^I[_[(0:MSB]A1:LSB])
               rbg4 CSɐ(0:"Lo"ANeBuA1:"Hi"ANeBu)
  
  SPIC^tF[Xɏ݂sȂAǂݏosȂ܂BANZX̑O
  CSΉrbgANeBuɂAANZXɃCANeBuɂ܂BANZX
  CS̃xModẽrbg4Ō܂܂B
  
  ]rbg8Ŋ؂ȂꍇAMSB]ꍇMSBɁALSB]
  ꍇɂLSBɃf[^l߂ĂB
  
  NbNʑ͏ݎƓǏoɕʁX̐ݒ肪\łBႦ93C46̂悤
  ȃfoCXɃANZXꍇAݎ̃NbNʑrbg0AǏõN
  bNʑrbg1Ƃ܂B̏ꍇAݎɂ̓X[uNbN̗
  Ńf[^TvOAǏoɂ̓}X^NbN̗Ńf[^
  TvO܂B
*****************************************************************************/

/*****************************************************************************
  void SPI_Write(void *pWrite, WORD nWriteBits, BYTE Mode)
  
  pWrite     : [in]݃f[^
  nWriteBits : ރrbg
  Mode       : 샂[h
               rbg0 NbNʑ(CPHA)
               rbg1 NbNɐ(CPOL)
               rbg2 f[^I[_[(0:MSB]A1:LSB])
               
  SPIC^tF[Xf[^o͂܂BCS(`bvZNg)M͑삳
  Bʓr|[gȂǂŐ䂷Kv܂B
*****************************************************************************/

/*****************************************************************************
  void SPI_Read(void *pRead, WORD nReadBits, BYTE Mode)
  
  pRead     : [out]ǂݏof[^̊i[
  nReadBits : ǂݏorbg
  Mode      : 샂[h
              rbg0 NbNʑ(CPHA)
              rbg1 NbNɐ(CPOL)
              rbg2 f[^I[_[(0:MSB]A1:LSB])
               
  SPIC^tF[Xf[^͂܂BCS(`bvZNg)M͑삳
  Bʓr|[gȂǂŐ䂷Kv܂B
*****************************************************************************/

/*****************************************************************************
  BYTE EE25_ReadStatus()
  
  ߂l : ǂݏoXe[^X

  SPIC^tF[X̃VAEEPROMp֐łBXe[^Xǂݏo܂B
*****************************************************************************/

/*****************************************************************************
  void EE25_WriteStatus(BYTE Status)
  
  Status : ރXe[^Xl
  
  SPIC^tF[X̃VAEEPROMp֐łBXe[^X݂܂B
*****************************************************************************/

/*****************************************************************************
  void EE25_WriteEnable(BOOL flgEnable)
  
  flgEnalbe : ݋/֎~
              TRUE  ݂܂B
              FALSE ݋֎~܂B
  
  SPIC^tF[X̃VAEEPROMp֐łB݂̋^֎~R}h
  ܂B
*****************************************************************************/

/*****************************************************************************
  void EE25_Write(DWORD Address, void *pData, WORD nWrite, int nAddressBits)
  
  Address      : EEPROM̃AhX
  pData        : [in]݃f[^
  nWrite       : ݃oCg
  nAddressBits : EEPROM̃AhX̃rbg(8,9,16,24,32)

  SPIC^tF[X̃VAEEPROMp֐łB݂s܂B݂̓o
  CgPʂōs܂B
  EEPROMɃy[WCg@\ꍇ́Af[^xɏ߂܂B
*****************************************************************************/

/*****************************************************************************
  void EE25_Read(DWORD Address, void *pData, WORD nWrite, int nAddressBits)
  
  Address      : EEPROM̃AhX
  pData        : [out]ǂݏof[^̊i[
  nRead        : ǂݏooCg
  nAddressBits : EEPROM̃AhX̃rbg(8,9,16,24,32)

  SPIC^tF[X̃VAEEPROMp֐łBǂݏosȂ܂BǏo
  oCgPʂōs܂B
  EEPROMɃV[PV[h@\ꍇ͕f[^xɓǂ߂܂B
*****************************************************************************/

/*****************************************************************************
  BOOL EE93_IsReady()
  
  ߂l : `bṽANZX
           TRUE  ANZX\
           FALSE /쒆BANZXs
           
  MicrowireC^tF[X̃VAEEPROMp֐łB݁A܂́A
  Iׂ܂B
*****************************************************************************/

/*****************************************************************************
  void EE93_WriteEnable(BOOL flgEnable, int nAddressBits)

  flgEnable    : ݋/֎~
                 TRUE  ݋
                 FALSE ݋֎~
  nAddressBits : AhXrbg
              
  MicrowireC^tF[X̃VAEEPROMp֐łB݂܂͋֎~R
  }h𑗐M܂B
*****************************************************************************/

/*****************************************************************************
  void EE93_EraseAll(int nAddressBits)
  
  nAddressBits : AhX̃rbg
  
  MicrowireC^tF[X̃VAEEPROMp֐łBSẴ̈
  ܂B
*****************************************************************************/

/*****************************************************************************
  void EE93_WriteAll(WORD Data, int nAddressBits)
  
  Data         : ރf[^(16rbgl)
  nAddressBits : AhX̃rbg

  MicrowireC^tF[X̃VAEEPROMp֐łBSẴ̈ɓl
  ݂܂B
*****************************************************************************/

/*****************************************************************************
  void EE93_Write(DWORD Address, WORD *pData,
                  WORD nDataWords, int nAddressBits)
  
  Address      : ݂sȂAhX
  pData        : [in]ރf[^
  nDataWords   : ރf[^([hP)
  nAddressBits : AhX̃rbg

  MicrowireC^tF[X̃VAEEPROMp֐łBf[^݂܂B
  ݂16rbgPʂōs܂̂ŒӂĂB
  EEPROMɃy[WCg@\ꍇ́Af[^xɏ߂܂B
*****************************************************************************/

/*****************************************************************************
  void EE93_Read(DWORD Address, void *pData, 
                 WORD nDataWords, int nAddressBits)
  
  Address      : ǂݏosȂAhX
  pData        : [out]ǂݏof[^̊i[
  nDataWords   : ǂݏof[^([hP)
  nAddressBits : AhX̃rbg

  MicrowireC^tF[X̃VAEEPROMp֐łBf[^ǂݏo܂B
  o16rbgPʂōs܂̂ŒӂĂB
  EEPROMɃV[PV[h@\ꍇ͕f[^xɓǂ߂܂B
*****************************************************************************/

