/*****************************************************************************
  M3069SerialDLL.cpp

  M3069}CR{[hI2C,SPI,Microwire ̃VAC^tF[Xgpł
  悤ɂ邽߂ɃCuB

  쐬 : 2007/8/14
  XV : 

  Ver.1.0.0.1

  Copyright (C) eNmEF[u2007
*****************************************************************************/
#include "stdafx.h"
#include "M3069SerialDLL.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
//	!
//
//		 DLL  MFC DLL ɑ΂ēIɃNꍇA
//		MFC ŌĂяo邱 DLL GNX|[gꂽ
//		ǂ̊֐֐̍ŏɒǉ AFX_MANAGE_STATE 
//		}N܂łȂ΂Ȃ܂B
//
//		:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// ʏ֐̖{̂͂̈ʒuɂ܂
//		}
//
//		̃}Ne֐Ɋ܂܂Ă邱ƁAMFC 
//		ǂ̌ĂяoD悷邱Ƃ͔ɏdvłB
//		͊֐̍ŏ̃Xe[ggłȂ΂
//		ȂƂӖ܂ARXgN^ MFC 
//		DLL ւ̌Ăяos\̂ŁAIu
//		WFNgϐ̐錾OłȂ΂Ȃ܂B
//
//		ڍׂɂĂ MFC eNjJ m[g 33 
//		58 QƂĂB
//

/////////////////////////////////////////////////////////////////////////////
// CM3069SerialDLLApp

BEGIN_MESSAGE_MAP(CM3069SerialDLLApp, CWinApp)
	//{{AFX_MSG_MAP(CM3069SerialDLLApp)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
		//        ̈ʒuɐR[hҏWȂłB
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CM3069SerialDLLApp ̍\z

CM3069SerialDLLApp::CM3069SerialDLLApp()
{
	// TODO: ̈ʒuɍ\zp̃R[hǉĂB
	//  InitInstance ̒̏dvȏׂċLqĂB
}

/////////////////////////////////////////////////////////////////////////////
// B CM3069SerialDLLApp IuWFNg

CM3069SerialDLLApp theApp;


#include"..\USBMLibrary\usbm3069.h"
#include"..\M3069Serial.h"
#pragma comment(lib, "..\\USBMLibrary\\usbm3069.lib")


/*****************************************************************************
  ATF̏
*****************************************************************************/
TW_STATUS _stdcall ATF_SerialAttach(TW_HANDLE hDev)
{
  CString str;

  //ATFt@CT
  SearchPath(NULL, _T("M3069Serial.atf"), NULL, MAX_PATH, str.GetBuffer(MAX_PATH), NULL);
  str.ReleaseBuffer();

  if(str.IsEmpty()) return TW_FILE_ERROR;

  //ATFt@C̃_E[h
  return USBM_ATFDownload(hDev, str, NULL);
}


TW_STATUS _stdcall ATF_SerialDetach(TW_HANDLE hDev)
{
  return USBM_ATFSetCommand(hDev, 0);
}

/*****************************************************************************
  I2C֘A֐
*****************************************************************************/
//I2CR}h
#define I2CC_SET_PORT    0x01
#define I2CC_SET_WAIT    0x02
#define I2CC_WRITE       0x03
#define I2CC_READ        0x04
#define I2CC_EE24_WRITE  0x05
#define I2CC_EE24_READ   0x06

//G[Xe[^X
#define I2CS_TIMEOUT 0x00010000 //SCL̉҂Ń^CAEgꍇ
#define I2CS_NACK    0x00020000 //NACKMꍇ


TW_STATUS _stdcall ATF_I2CSetPort(TW_HANDLE hDev, DWORD Port, long SclBit, long SdaBit, BYTE DDR)
{
  DWORD Param2;
  Param2 = SclBit;
  Param2 |= SdaBit << 8;
  Param2 |= (DWORD)DDR << 16;

  return USBM_ATFUserCommand(hDev, I2CC_SET_PORT, Port, Param2);
}


TW_STATUS _stdcall ATF_I2CSetWait(TW_HANDLE hDev, BYTE Wait)
{
  DWORD Param1 = Wait;

  return USBM_ATFUserCommand(hDev, I2CC_SET_WAIT, Param1);
}


TW_STATUS _stdcall ATF_I2CWrite(TW_HANDLE hDev, BYTE SlaveAddr, void *pData, long *pnWrite, long Condition)
{
  TW_STATUS ret;
  DWORD dwTemp;
  DWORD n;

  //p[^̃`FbN
  if(!pnWrite) return TW_INVALID_ARGS;
  if(!pData) return TW_INVALID_ARGS;

  //R}h̃p[^ݒ
  dwTemp = SlaveAddr;
  dwTemp |= Condition << 16;

  //R}h̑M
  if(ret = USBM_ATFUserCommand(hDev, I2CC_WRITE, *pnWrite, dwTemp)) return ret;
  //f[^̑M
  if(ret = USBM_Write(hDev, pData, *pnWrite, &n)) return ret;
  //ʂ̎M
  if(ret = USBM_Read(hDev, &dwTemp, 4, &n)) return ret;
  //USBM_Read(), USBM_Write()ő󂵂f[^̓oCgI[_[̕ύXKv
  dwTemp = htonl(dwTemp); //oCgI[_[ύX

  *pnWrite = dwTemp & 0xffff; //߂oCgۑ

  //G[Xe[^X̃`FbN
  if(dwTemp & I2CS_TIMEOUT) ret = TW_I2CS_TIMEOUT;
  else if(dwTemp & I2CS_NACK) ret = TW_I2CS_NACK;

  return ret;
}


TW_STATUS _stdcall ATF_I2CRead(TW_HANDLE hDev, BYTE SlaveAddr, void *pData, long *pnRead, long Condition)
{
  TW_STATUS ret;
  DWORD dwTemp;
  DWORD n;

  //p[^̃`FbN
  if(!pnRead) return TW_INVALID_ARGS;
  if(!pData) return TW_INVALID_ARGS;

  //R}h̃p[^ݒ
  dwTemp = SlaveAddr;
  dwTemp |= Condition << 16;

  //R}h̑M
  if(ret = USBM_ATFUserCommand(hDev, I2CC_READ, *pnRead, dwTemp)) return ret;
  //ʂ̎M
  if(ret = USBM_Read(hDev, &dwTemp, 4, &n)) return ret;
  //USBM_Read(), USBM_Write()ő󂵂f[^̓oCgI[_[̕ύXKv
  dwTemp = htonl(dwTemp);    //oCgI[_[ύX
  *pnRead = dwTemp & 0xffff; //ǂݏooCgۑ
  //f[^̎M
  ret = USBM_Read(hDev, pData, *pnRead, &n);
  if(ret){ //G[̏ꍇ
    *pnRead = n; //ǂݏooCg
    return ret;
  }
  //G[Xe[^X̃`FbN
  if(dwTemp & I2CS_TIMEOUT) ret = TW_I2CS_TIMEOUT;
  else if(dwTemp & I2CS_NACK) ret = TW_I2CS_NACK;

  return ret;
}


TW_STATUS _stdcall ATF_EE24Write(TW_HANDLE hDev, BYTE SlaveAddr, DWORD Addr, void *pData, long *pnWrite, long nAddrBits)
{
  TW_STATUS ret;
  DWORD dwTemp;
  WORD wTemp;
  DWORD n;

  //p[^̃`FbN
  if(!pnWrite) return TW_INVALID_ARGS;
  if(!pData) return TW_INVALID_ARGS;

  //R}h̃p[^ݒ
  dwTemp = SlaveAddr;
  dwTemp |= nAddrBits << 8;
  dwTemp |= *pnWrite << 16;

  //R}h̑M
  if(ret = USBM_ATFUserCommand(hDev, I2CC_EE24_WRITE, Addr, dwTemp)) return ret;
  //f[^̑M
  if(ret = USBM_Write(hDev, pData, *pnWrite, &n)) return ret;
  //ʂ̎M
  if(ret = USBM_Read(hDev, &wTemp, 2, &n)) return ret;
  //USBM_Read(), USBM_Write()ő󂵂f[^̓oCgI[_[̕ύXKv
  *pnWrite = htons(wTemp); //oCgI[_[ύX

  return ret;
}


TW_STATUS _stdcall ATF_EE24Read(TW_HANDLE hDev, BYTE SlaveAddr, DWORD Addr, void *pData, long *pnRead, long nAddrBits)
{
  TW_STATUS ret;
  DWORD dwTemp;
  WORD wTemp;
  DWORD n;

  //p[^̃`FbN
  if(!pnRead) return TW_INVALID_ARGS;
  if(!pData) return TW_INVALID_ARGS;

  //R}h̃p[^ݒ
  dwTemp = SlaveAddr;
  dwTemp |= nAddrBits << 8;
  dwTemp |= *pnRead << 16;

  //R}h̑M
  if(ret = USBM_ATFUserCommand(hDev, I2CC_EE24_READ, Addr, dwTemp)) return ret;
  //ʂ̎M
  if(ret = USBM_Read(hDev, &wTemp, 2, &n)) return ret;
  //USBM_Read(), USBM_Write()ő󂵂f[^̓oCgI[_[̕ύXKv
  *pnRead = htons(wTemp); //oCgI[_[ύX

  //f[^̎M
  ret = USBM_Read(hDev, pData, *pnRead, &n);
  if(ret) *pnRead = n; //ǂݏooCg

  return ret;
}


/*****************************************************************************
  SPI֘A֐
*****************************************************************************/
//SPIR}h
//SPIR}h
#define SPIC_SET_PORT          0x10
#define SPIC_SET_WAIT          0x11
#define SPIC_WRITE_READ        0x12
#define SPIC_WRITE             0x13
#define SPIC_READ              0x14
#define SPIC_EE25_WRITE_STATUS 0x15
#define SPIC_EE25_READ_STATUS  0x16
#define SPIC_EE25_WRITE_ENABLE 0x17
#define SPIC_EE25_WRITE        0x18
#define SPIC_EE25_READ         0x19
#define SPIC_EE93_WRITE_ENABLE 0x1a
#define SPIC_EE93_ERASE_ALL    0x1b
#define SPIC_EE93_WRITE_ALL    0x1c
#define SPIC_EE93_WRITE        0x1d
#define SPIC_EE93_READ         0x1e
#define SPIC_EE93_IS_READY     0x1f


TW_STATUS _stdcall ATF_SPISetPort(TW_HANDLE hDev, DWORD Port, long CLKBit, long DOBit, long DIBit, DWORD CSPort, BYTE CSBits)
{
  BYTE bBuff[4];
  
  bBuff[0] = (BYTE)CLKBit;
  bBuff[1] = (BYTE)DOBit;
  bBuff[2] = (BYTE)DIBit;
  bBuff[3] = (BYTE)CSBits;
  return USBM_ATFUserCommand(hDev, SPIC_SET_PORT, Port, CSPort, bBuff, 4);
}


TW_STATUS _stdcall ATF_SPISetWait(TW_HANDLE hDev, WORD Wait)
{
  return USBM_ATFUserCommand(hDev, SPIC_SET_WAIT, Wait);
}


TW_STATUS _stdcall ATF_SPIWriteRead(TW_HANDLE hDev, void *pWrite, long nWriteBits, void *pRead, long nReadBits, BYTE Mode)
{
  TW_STATUS ret;
  DWORD nBytes;

  //݃rbgƓǏorbg`FbN
  if(nWriteBits > 2048 || nReadBits > 2048) return TW_INVALID_ARGS;

  nBytes = (nWriteBits + 7) >> 3; //݃rbgoCgɕϊ

  //R}hƏ݃f[^𑗐M
  ret = USBM_ATFUserCommand(hDev, SPIC_WRITE_READ, nWriteBits | (nReadBits << 16), Mode, pWrite, nBytes);
  if(ret) return ret;

  nBytes = (nReadBits + 7) >> 3; //ǏorbgoCgɕϊ

  //f[^̓Ǐo
  return USBM_Read(hDev, pRead, nBytes, &nBytes);
}


TW_STATUS _stdcall ATF_SPIWrite(TW_HANDLE hDev, void *pWrite, long nWriteBits, BYTE Mode)
{
  DWORD nBytes;

  //݃rbg`FbN
  if(nWriteBits > 2048) return TW_INVALID_ARGS;

  nBytes = (nWriteBits + 7) >> 3; //݃rbgoCgɕϊ

  //R}hƏ݃f[^𑗐M
  return USBM_ATFUserCommand(hDev, SPIC_WRITE, nWriteBits, Mode, pWrite, nBytes);
}


TW_STATUS _stdcall ATF_SPIRead(TW_HANDLE hDev, void *pRead, long nReadBits, BYTE Mode)
{
  TW_STATUS ret;
  DWORD nBytes;

  //Ǐorbg`FbN
  if(nReadBits > 2048) return TW_INVALID_ARGS;

  nBytes = (nReadBits + 7) >> 3; //ǏorbgoCgɕϊ

  //R}h𑗐M
  if(ret = USBM_ATFUserCommand(hDev, SPIC_READ, nReadBits, Mode)) return ret;

  //f[^M
  return USBM_Read(hDev, pRead, nBytes, &nBytes);
}


TW_STATUS _stdcall ATF_EE25ReadStatus(TW_HANDLE hDev, BYTE *pStatus)
{
  TW_STATUS ret;
  DWORD n;

  //R}hM
  if(ret = USBM_ATFUserCommand(hDev, SPIC_EE25_READ_STATUS)) return ret;
  
  //Xe[^XM
  return USBM_Read(hDev, pStatus, 1, &n);
}


TW_STATUS _stdcall ATF_EE25WriteStatus(TW_HANDLE hDev, BYTE Status)
{
  return USBM_ATFUserCommand(hDev, SPIC_EE25_WRITE_STATUS, Status);
}


TW_STATUS _stdcall ATF_EE25Write(TW_HANDLE hDev, DWORD Addr, void *pData, long nWrite, long nAddrBits)
{
  TW_STATUS ret;
  DWORD t;
  BYTE Status;

  if(nWrite > 256) return TW_INVALID_ARGS;
  
  //݉\ׂ
  t = GetTickCount();
  while(1){
    if(ret = ATF_EE25ReadStatus(hDev, &Status)) return ret; //Xe[^X̓Ǐo
    if((Status & 0x01) == 0) break; //ݒXe[^Xrbg`FbN
    if(GetTickCount() - t > 1000) return TW_TIMEOUT; //1bo߂^CAEgƂ
  }

  //
  ret = USBM_ATFUserCommand(hDev, SPIC_EE25_WRITE, Addr, (nAddrBits << 16) | nWrite, pData, nWrite);
  if(ret) return ret;

  //݂Iׂ
  t = GetTickCount();
  while(1){
    if(ret = ATF_EE25ReadStatus(hDev, &Status)) return ret; //Xe[^X̓Ǐo
    if((Status & 0x01) == 0) break; //ݒXe[^Xrbg`FbN
    if(GetTickCount() - t > 1000) return TW_TIMEOUT; //1bo߂^CAEgƂ
  }
  return TW_OK;
}


TW_STATUS _stdcall ATF_EE25Read(TW_HANDLE hDev, DWORD Addr, void *pData, long nRead, long nAddrBits)
{
  TW_STATUS ret;
  DWORD n;

  if(nRead > 256) return TW_INVALID_ARGS;

  //R}h𑗐M
  ret = USBM_ATFUserCommand(hDev, SPIC_EE25_READ, Addr, (nAddrBits << 16) | nRead);
  if(ret) return ret;

  //f[^M
  return USBM_Read(hDev, pData, nRead, &n);
}


TW_STATUS _stdcall ATF_EE93WriteEnable(TW_HANDLE hDev, BOOL flgEnable, long nAddrBits)
{
  return USBM_ATFUserCommand(hDev, SPIC_EE93_WRITE_ENABLE, flgEnable, nAddrBits);
}


TW_STATUS _stdcall ATF_EE93EraseAll(TW_HANDLE hDev, long nAddrBits)
{
  TW_STATUS ret;
  DWORD t;
  BOOL ready;

  //݉\`FbN
  t = GetTickCount();
  while(1){
    if(ret = ATF_EE93IsReady(hDev, &ready)) return ret; //Ԃ̓Ǐo
    if(ready) break; //ǂݏotO`FbN
    if(GetTickCount() - t > 1000) return TW_TIMEOUT; //1bo߂^CAEgƂ
  }

  //R}h𑗐M
  ret = USBM_ATFUserCommand(hDev, SPIC_EE93_ERASE_ALL, nAddrBits);
  if(ret) return ret;

  //R}h̏I`FbN
  t = GetTickCount();
  while(1){
    if(ret = ATF_EE93IsReady(hDev, &ready)) return ret; //Ԃ̓Ǐo
    if(ready) break; //ǂݏotO`FbN
    if(GetTickCount() - t > 1000) return TW_TIMEOUT; //1bo߂^CAEgƂ
  }
  return TW_OK;
}


TW_STATUS _stdcall ATF_EE93WriteAll(TW_HANDLE hDev, WORD Data, long nAddrBits)
{
  TW_STATUS ret;
  DWORD t;
  BOOL ready;

  //݉\`FbN
  t = GetTickCount();
  while(1){
    if(ret = ATF_EE93IsReady(hDev, &ready)) return ret; //Ԃ̓Ǐo
    if(ready) break; //ǂݏotO`FbN
    if(GetTickCount() - t > 1000) return TW_TIMEOUT; //1bo߂^CAEgƂ
  }

  Data = htons(Data);

  //R}h𑗐M
  ret = USBM_ATFUserCommand(hDev, SPIC_EE93_WRITE_ALL, Data, nAddrBits);
  if(ret) return ret;

  //R}h̏I`FbN
  t = GetTickCount();
  while(1){
    if(ret = ATF_EE93IsReady(hDev, &ready)) return ret; //Ԃ̓Ǐo
    if(ready) break; //ǂݏotO`FbN
    if(GetTickCount() - t > 1000) return TW_TIMEOUT; //1bo߂^CAEgƂ
  }
  return TW_OK;
}


TW_STATUS _stdcall ATF_EE93Write(TW_HANDLE hDev, DWORD Addr, void *pData, WORD nDataWords, long nAddrBits)
{
  TW_STATUS ret;
  DWORD t;
  BOOL ready;

  if(nDataWords > 128) return TW_INVALID_ARGS;

  //݉\`FbN
  t = GetTickCount();
  while(1){
    if(ret = ATF_EE93IsReady(hDev, &ready)) return ret; //Ԃ̓Ǐo
    if(ready) break; //ǂݏotO`FbN
    if(GetTickCount() - t > 1000) return TW_TIMEOUT; //1bo߂^CAEgƂ
  }

  //R}h𑗐M
  ret = USBM_ATFUserCommand(hDev, SPIC_EE93_WRITE, Addr, (nAddrBits << 16) | nDataWords, pData, nDataWords * 2);
  if(ret) return ret;

  //R}h̏I`FbN
  t = GetTickCount();
  while(1){
    if(ret = ATF_EE93IsReady(hDev, &ready)) return ret; //Ԃ̓Ǐo
    if(ready) break; //ǂݏotO`FbN
    if(GetTickCount() - t > 1000) return TW_TIMEOUT; //1bo߂^CAEgƂ
  }
  return TW_OK;
}


TW_STATUS _stdcall ATF_EE93Read(TW_HANDLE hDev, DWORD Addr, void *pData, WORD nDataWords, long nAddrBits)
{
  TW_STATUS ret;
  DWORD n;

  if(nDataWords > 128) return TW_INVALID_ARGS;

  //R}h𑗐M
  ret = USBM_ATFUserCommand(hDev, SPIC_EE93_READ, Addr, (nAddrBits << 16) | nDataWords);
  if(ret) return ret;

  //f[^M
  return USBM_Read(hDev, pData, nDataWords * 2, &n);
}


TW_STATUS _stdcall ATF_EE93IsReady(TW_HANDLE hDev, BOOL *pflgReady)
{
  TW_STATUS ret;
  DWORD n;

  //R}h𑗐M
  if(ret = USBM_ATFUserCommand(hDev, SPIC_EE93_IS_READY)) return ret;
  
  //tOM
  return USBM_Read(hDev, pflgReady, 1, &n);
}
