	segment	TEXT ATR_CODE
public	_SPI_WriteRead
_SPI_WriteRead:
;	pWrite	8(er6)
;	nWriteBits	12(er6)
;	pRead	14(er6)
;	nReadBits	18(er6)
;	Mode	21(er6)
	PUSH.L	ER6
	MOV.L	ER7,ER6
                                         
;                                        SPI.c(53)
	MOV.B	@(+21,ER6),R0L
	EXTU.W	R0
	AND.W	#H'0010,R0
	OR.W	R0,R0
	BEQ	?00000:8
;                                        SPI.c(53)
	MOV.L	@_pSPI_CSPort,ER0
	MOV.B	@ER0,R1L
	MOV.B	@_SPI_CSBits,R2L
	OR.B	R2L,R1L
	MOV.B	R1L,@ER0
	BRA	?00001:8
?00000:
;                                        SPI.c(54)
	MOV.B	@_SPI_CSBits,R0L
	EXTU.W	R0
	NOT.W	R0
	MOV.L	@_pSPI_CSPort,ER1
	MOV.B	@ER1,R2L
	AND.B	R0L,R2L
	MOV.B	R2L,@ER1
?00001:
;                                        SPI.c(56)
	MOV.B	@(+21,ER6),R0L
	EXTU.W	R0
	SHAR.W	R0
	PUSH.W	R0
	MOV.W	@(+12,ER6),R0
	PUSH.W	R0
	MOV.L	@(+8,ER6),ER1
	PUSH.L	ER1
	JSR	@_SPI_Write
	ADDS.L	#H'00000004,ER7
	ADDS.L	#H'00000004,ER7
;                                        SPI.c(57)
	MOV.B	@(+21,ER6),R0L
	EXTU.W	R0
	MOV.W	R0,R1
	AND.W	#H'0001,R1
	SHAR.W	R0
	AND.W	#H'00FE,R0
	OR.W	R1,R0
	PUSH.W	R0
	MOV.W	@(+18,ER6),R0
	PUSH.W	R0
	MOV.L	@(+14,ER6),ER1
	PUSH.L	ER1
	JSR	@_SPI_Read
	ADDS.L	#H'00000004,ER7
	ADDS.L	#H'00000004,ER7
;                                        SPI.c(60)
	MOV.B	@(+21,ER6),R0L
	EXTU.W	R0
	AND.W	#H'0010,R0
	OR.W	R0,R0
	BEQ	?00002:8
;                                        SPI.c(60)
	MOV.B	@_SPI_CSBits,R0L
	EXTU.W	R0
	NOT.W	R0
	MOV.L	@_pSPI_CSPort,ER1
	MOV.B	@ER1,R2L
	AND.B	R0L,R2L
	MOV.B	R2L,@ER1
	BRA	?00003:8
?00002:
;                                        SPI.c(61)
	MOV.L	@_pSPI_CSPort,ER0
	MOV.B	@ER0,R1L
	MOV.B	@_SPI_CSBits,R2L
	OR.B	R2L,R1L
	MOV.B	R1L,@ER0
?00003:
;                                        SPI.c(62)
_SPI_WriteRead_end:

	POP.L	ER6
	RTS

	segment	TEXT ATR_CODE
public	_SPI_SetPort
_SPI_SetPort:
;	Port	8(er6)
;	CLKBit	12(er6)
;	DOBit	14(er6)
;	DIBit	16(er6)
;	CSPort	18(er6)
;	CSBits	23(er6)
	PUSH.L	ER6
	MOV.L	ER7,ER6
                                         
;                                        SPI.c(85)
	MOV.L	@(+18,ER6),ER0
	OR.L	ER0,ER0
	BNE	?00004:8
;                                        SPI.c(86)
	MOV.L	@(+8,ER6),ER0
	MOV.L	ER0,@(+18,ER6)
;                                        SPI.c(87)
	XOR.B	R1L,R1L
	MOV.B	R1L,@(+23,ER6)
?00004:
;                                        SPI.c(89)
	MOV.L	@(+8,ER6),ER0
	MOV.L	ER0,@_SPI_PortAddress
;                                        SPI.c(90)
	MOV.W	@(+12,ER6),R1
	MOV.B	R1L,@_SPI_ClkBit
;                                        SPI.c(91)
	MOV.W	@(+14,ER6),R2
	MOV.B	R2L,@_SPI_DOBit
;                                        SPI.c(92)
	MOV.W	@(+16,ER6),R3
	MOV.B	R3L,@_SPI_DIBit
;                                        SPI.c(93)
	MOV.L	@(+18,ER6),ER4
	MOV.L	ER4,@_pSPI_CSPort
;                                        SPI.c(94)
	MOV.B	@(+23,ER6),R0L
	MOV.B	R0L,@_SPI_CSBits
;                                        SPI.c(95)
_SPI_SetPort_end:

	POP.L	ER6
	RTS

	segment	TEXT ATR_CODE
public	_SPI_SetWait
_SPI_SetWait:
;	Wait	8(er6)
	PUSH.L	ER6
	MOV.L	ER7,ER6
                                         
;                                        SPI.c(108)
	MOV.W	@(+8,ER6),R0
	MOV.W	R0,@_SPI_Wait
;                                        SPI.c(109)
_SPI_SetWait_end:

	POP.L	ER6
	RTS

	segment	TEXT ATR_CODE
public	_EE25_ReadStatus
_EE25_ReadStatus:
;	bCmd	-1(er6)
;	bStatus	-2(er6)
	PUSH.L	ER6
	MOV.L	ER7,ER6
	SUBS	#2,ER7
                           
;                                        SPI.c(121)
	MOV.B	#H'05,R0L
	MOV.B	R0L,@(-1,ER6)
;                                        SPI.c(125)
	MOV.B	@_SPI_CSBits,R0L
	EXTU.W	R0
	NOT.W	R0
	MOV.L	@_pSPI_CSPort,ER1
	MOV.B	@ER1,R2L
	AND.B	R0L,R2L
	MOV.B	R2L,@ER1
;                                        SPI.c(127)
	XOR.W	R0,R0
	PUSH.W	R0
	MOV.W	#H'0008,R1
	PUSH.W	R1
	MOV.L	ER6,ER2
	ADD.L	#H'FFFFFFFF,ER2
	PUSH.L	ER2
	JSR	@_SPI_Write
	ADDS.L	#H'00000004,ER7
	ADDS.L	#H'00000004,ER7
;                                        SPI.c(128)
	XOR.W	R0,R0
	PUSH.W	R0
	MOV.W	#H'0008,R1
	PUSH.W	R1
	MOV.L	ER6,ER2
	ADD.L	#H'FFFFFFFE,ER2
	PUSH.L	ER2
	JSR	@_SPI_Read
	ADDS.L	#H'00000004,ER7
	ADDS.L	#H'00000004,ER7
;                                        SPI.c(131)
	MOV.L	@_pSPI_CSPort,ER0
	MOV.B	@ER0,R1L
	MOV.B	@_SPI_CSBits,R2L
	OR.B	R2L,R1L
	MOV.B	R1L,@ER0
;                                        SPI.c(133)
	MOV.B	@(-2,ER6),R0L
;                                        SPI.c(134)
_EE25_ReadStatus_end:

	MOV.L	ER6,ER7
	POP.L	ER6
	RTS

	segment	TEXT ATR_CODE
public	_EE25_WriteStatus
_EE25_WriteStatus:
;	Status	9(er6)
;	bData	-2(er6)
	PUSH.L	ER6
	MOV.L	ER7,ER6
	SUBS	#2,ER7
                           
;                                        SPI.c(146)
	MOV.B	#H'01,R0L
	MOV.B	R0L,@(-2,ER6)
	XOR.B	R0L,R0L
	MOV.B	R0L,@(-1,ER6)
;                                        SPI.c(148)
	MOV.L	ER6,ER0
	ADD.L	#H'FFFFFFFE,ER0
	MOV.B	@(+9,ER6),R1L
	MOV.B	R1L,@(+1,ER0)
;                                        SPI.c(151)
	MOV.B	@_SPI_CSBits,R0L
	EXTU.W	R0
	NOT.W	R0
	MOV.L	@_pSPI_CSPort,ER1
	MOV.B	@ER1,R2L
	AND.B	R0L,R2L
	MOV.B	R2L,@ER1
;                                        SPI.c(153)
	XOR.W	R0,R0
	PUSH.W	R0
	MOV.W	#H'0010,R1
	PUSH.W	R1
	MOV.L	ER6,ER2
	ADD.L	#H'FFFFFFFE,ER2
	PUSH.L	ER2
	JSR	@_SPI_Write
	ADDS.L	#H'00000004,ER7
	ADDS.L	#H'00000004,ER7
;                                        SPI.c(156)
	MOV.L	@_pSPI_CSPort,ER0
	MOV.B	@ER0,R1L
	MOV.B	@_SPI_CSBits,R2L
	OR.B	R2L,R1L
	MOV.B	R1L,@ER0
;                                        SPI.c(157)
_EE25_WriteStatus_end:

	MOV.L	ER6,ER7
	POP.L	ER6
	RTS

	segment	TEXT ATR_CODE
public	_EE25_WriteEnable
_EE25_WriteEnable:
;	flgEnable	8(er6)
;	bCmd	-1(er6)
	PUSH.L	ER6
	MOV.L	ER7,ER6
	SUBS	#2,ER7
                           
;                                        SPI.c(172)
	MOV.B	#H'06,R0L
	MOV.B	R0L,@(-1,ER6)
;                                        SPI.c(173)
	MOV.W	@(+8,ER6),R0
	OR.W	R0,R0
	BEQ	?00005:8
;                                        SPI.c(173)
	MOV.B	#H'06,R0L
	MOV.B	R0L,@(-1,ER6)
	BRA	?00006:8
?00005:
;                                        SPI.c(174)
	MOV.B	#H'04,R0L
	MOV.B	R0L,@(-1,ER6)
?00006:
;                                        SPI.c(177)
	MOV.B	@_SPI_CSBits,R0L
	EXTU.W	R0
	NOT.W	R0
	MOV.L	@_pSPI_CSPort,ER1
	MOV.B	@ER1,R2L
	AND.B	R0L,R2L
	MOV.B	R2L,@ER1
;                                        SPI.c(179)
	XOR.W	R0,R0
	PUSH.W	R0
	MOV.W	#H'0008,R1
	PUSH.W	R1
	MOV.L	ER6,ER2
	ADD.L	#H'FFFFFFFF,ER2
	PUSH.L	ER2
	JSR	@_SPI_Write
	ADDS.L	#H'00000004,ER7
	ADDS.L	#H'00000004,ER7
;                                        SPI.c(182)
	MOV.L	@_pSPI_CSPort,ER0
	MOV.B	@ER0,R1L
	MOV.B	@_SPI_CSBits,R2L
	OR.B	R2L,R1L
	MOV.B	R1L,@ER0
;                                        SPI.c(183)
_EE25_WriteEnable_end:

	MOV.L	ER6,ER7
	POP.L	ER6
	RTS

	segment	TEXT ATR_CODE
public	_EE25_Write
_EE25_Write:
;	Address	8(er6)
;	pData	12(er6)
;	nWrite	16(er6)
;	nAddressBits	18(er6)
;	bCmd	-1(er6)
;	bStatus	-2(er6)
;	nWriteBits	-4(er6)
	PUSH.L	ER6
	MOV.L	ER7,ER6
	SUBS	#4,ER7
                           
;                                        SPI.c(204)
	MOV.B	#H'02,R0L
	MOV.B	R0L,@(-1,ER6)
;                                        SPI.c(205)
	MOV.W	@(+16,ER6),R1
	SHLL.W	R1
	SHLL.W	R1
	SHLL.W	R1
	MOV.W	R1,@(+16,ER6)
;                                        SPI.c(208)
	MOV.W	@(+18,ER6),R2
	CMP.W	#H'0009,R2
	BNE	?00007:8
;                                        SPI.c(209)
	MOV.L	@(+8,ER6),ER0
	AND.L	#H'00000100,ER0
	OR.L	ER0,ER0
	BEQ	?00008:8
;                                        SPI.c(209)
	MOV.B	@(-1,ER6),R0L
	OR.B	#H'08,R0L
	MOV.B	R0L,@(-1,ER6)
?00008:
;                                        SPI.c(210)
	MOV.W	#H'0008,R0
	MOV.W	R0,@(+18,ER6)
?00007:
;                                        SPI.c(212)
	MOV.W	@(+18,ER6),R0
	ADD.W	#H'0007,R0
	AND.W	#H'FFF8,R0
	MOV.W	R0,@(+18,ER6)
;                                        SPI.c(213)
	MOV.W	#H'0020,R1
	SUB.W	R0,R1
	MOV.L	@(+8,ER6),ER2
	PUSH.W	R1
	PUSH.L	ER2
	JSR	@__l_shift_sl
	ADDS.L	#H'00000002,ER7
	POP.L	ER2
	MOV.L	ER2,@(+8,ER6)
;                                        SPI.c(216)
	MOV.B	@_SPI_CSBits,R1L
	EXTU.W	R1
	NOT.W	R1
	MOV.L	@_pSPI_CSPort,ER3
	MOV.B	@ER3,R4L
	AND.B	R1L,R4L
	MOV.B	R4L,@ER3
;                                        SPI.c(218)
	XOR.W	R0,R0
	PUSH.W	R0
	MOV.W	#H'0008,R1
	PUSH.W	R1
	MOV.L	ER6,ER2
	ADD.L	#H'FFFFFFFF,ER2
	PUSH.L	ER2
	JSR	@_SPI_Write
	ADDS.L	#H'00000004,ER7
	ADDS.L	#H'00000004,ER7
;                                        SPI.c(219)
	XOR.W	R0,R0
	PUSH.W	R0
	MOV.W	@(+18,ER6),R1
	PUSH.W	R1
	MOV.L	ER6,ER2
	ADD.L	#H'00000008,ER2
	PUSH.L	ER2
	JSR	@_SPI_Write
	ADDS.L	#H'00000004,ER7
	ADDS.L	#H'00000004,ER7
;                                        SPI.c(220)
	XOR.W	R0,R0
	PUSH.W	R0
	MOV.W	@(+16,ER6),R1
	PUSH.W	R1
	MOV.L	@(+12,ER6),ER2
	PUSH.L	ER2
	JSR	@_SPI_Write
	ADDS.L	#H'00000004,ER7
	ADDS.L	#H'00000004,ER7
;                                        SPI.c(223)
	MOV.L	@_pSPI_CSPort,ER0
	MOV.B	@ER0,R1L
	MOV.B	@_SPI_CSBits,R2L
	OR.B	R2L,R1L
	MOV.B	R1L,@ER0
;                                        SPI.c(224)
_EE25_Write_end:

	MOV.L	ER6,ER7
	POP.L	ER6
	RTS

	segment	TEXT ATR_CODE
public	_EE25_Read
_EE25_Read:
;	Address	8(er6)
;	pData	12(er6)
;	nRead	16(er6)
;	nAddressBits	18(er6)
;	bCmd	-1(er6)
;	bStatus	-2(er6)
;	wTmp	-4(er6)
;	nWriteBits	-6(er6)
	PUSH.L	ER6
	MOV.L	ER7,ER6
	SUB.L	#6,ER7
                          
;                                        SPI.c(246)
	MOV.B	#H'03,R0L
	MOV.B	R0L,@(-1,ER6)
;                                        SPI.c(247)
	MOV.W	@(+16,ER6),R1
	SHLL.W	R1
	SHLL.W	R1
	SHLL.W	R1
	MOV.W	R1,@(+16,ER6)
;                                        SPI.c(250)
	MOV.W	@(+18,ER6),R2
	CMP.W	#H'0009,R2
	BNE	?00009:8
;                                        SPI.c(251)
	MOV.L	@(+8,ER6),ER0
	AND.L	#H'00000100,ER0
	OR.L	ER0,ER0
	BEQ	?00010:8
;                                        SPI.c(251)
	MOV.B	@(-1,ER6),R0L
	OR.B	#H'08,R0L
	MOV.B	R0L,@(-1,ER6)
?00010:
;                                        SPI.c(252)
	MOV.W	#H'0008,R0
	MOV.W	R0,@(+18,ER6)
?00009:
;                                        SPI.c(255)
	MOV.W	@(+18,ER6),R0
	ADD.W	#H'0007,R0
	AND.W	#H'FFF8,R0
	MOV.W	R0,@(+18,ER6)
;                                        SPI.c(256)
	MOV.W	#H'0020,R1
	SUB.W	R0,R1
	MOV.L	@(+8,ER6),ER2
	PUSH.W	R1
	PUSH.L	ER2
	JSR	@__l_shift_sl
	ADDS.L	#H'00000002,ER7
	POP.L	ER2
	MOV.L	ER2,@(+8,ER6)
;                                        SPI.c(259)
	MOV.B	@_SPI_CSBits,R1L
	EXTU.W	R1
	NOT.W	R1
	MOV.L	@_pSPI_CSPort,ER3
	MOV.B	@ER3,R4L
	AND.B	R1L,R4L
	MOV.B	R4L,@ER3
;                                        SPI.c(261)
	XOR.W	R0,R0
	PUSH.W	R0
	MOV.W	#H'0008,R1
	PUSH.W	R1
	MOV.L	ER6,ER2
	ADD.L	#H'FFFFFFFF,ER2
	PUSH.L	ER2
	JSR	@_SPI_Write
	ADDS.L	#H'00000004,ER7
	ADDS.L	#H'00000004,ER7
;                                        SPI.c(262)
	XOR.W	R0,R0
	PUSH.W	R0
	MOV.W	@(+18,ER6),R1
	PUSH.W	R1
	MOV.L	ER6,ER2
	ADD.L	#H'00000008,ER2
	PUSH.L	ER2
	JSR	@_SPI_Write
	ADDS.L	#H'00000004,ER7
	ADDS.L	#H'00000004,ER7
;                                        SPI.c(263)
	XOR.W	R0,R0
	PUSH.W	R0
	MOV.W	@(+16,ER6),R1
	PUSH.W	R1
	MOV.L	@(+12,ER6),ER2
	PUSH.L	ER2
	JSR	@_SPI_Read
	ADDS.L	#H'00000004,ER7
	ADDS.L	#H'00000004,ER7
;                                        SPI.c(266)
	MOV.L	@_pSPI_CSPort,ER0
	MOV.B	@ER0,R1L
	MOV.B	@_SPI_CSBits,R2L
	OR.B	R2L,R1L
	MOV.B	R1L,@ER0
;                                        SPI.c(267)
_EE25_Read_end:

	MOV.L	ER6,ER7
	POP.L	ER6
	RTS

	segment	TEXT ATR_CODE
_EE93_SendCmd:
;	pCmd	8(er6)
;	nAddressBits	12(er6)
	PUSH.L	ER6
	MOV.L	ER7,ER6
                                         
;                                        SPI.c(281)
	MOV.L	@_pSPI_CSPort,ER0
	MOV.B	@ER0,R1L
	MOV.B	@_SPI_CSBits,R2L
	OR.B	R2L,R1L
	MOV.B	R1L,@ER0
;                                        SPI.c(287)
	XOR.W	R0,R0
	PUSH.W	R0
	MOV.W	@(+12,ER6),R1
	ADDS.L	#H'00000004,ER1
	PUSH.W	R1
	MOV.L	@(+8,ER6),ER1
	PUSH.L	ER1
	JSR	@_SPI_Write
	ADDS.L	#H'00000004,ER7
	ADDS.L	#H'00000004,ER7
;                                        SPI.c(290)
	MOV.B	@_SPI_CSBits,R0L
	EXTU.W	R0
	NOT.W	R0
	MOV.L	@_pSPI_CSPort,ER1
	MOV.B	@ER1,R2L
	AND.B	R0L,R2L
	MOV.B	R2L,@ER1
;                                        SPI.c(291)
_EE93_SendCmd_end:

	POP.L	ER6
	RTS

	segment	TEXT ATR_CODE
public	_EE93_IsReady
_EE93_IsReady:
;	i	-2(er6)
;	TestBit	-3(er6)
;	pPort	-8(er6)
;	ret	-10(er6)
	PUSH.L	ER6
	MOV.L	ER7,ER6
	SUB.L	#10,ER7
                         
;                                        SPI.c(307)
	MOV.B	#H'01,R0L
	MOV.B	R0L,@(-3,ER6)
;                                        SPI.c(312)
	MOV.L	@_pSPI_CSPort,ER0
	MOV.B	@ER0,R1L
	MOV.B	@_SPI_CSBits,R2L
	OR.B	R2L,R1L
	MOV.B	R1L,@ER0
;                                        SPI.c(314)
	MOV.L	@_SPI_PortAddress,ER0
	MOV.L	ER0,@(-8,ER6)
;                                        SPI.c(315)
	MOV.B	@_SPI_DIBit,R1L
	EXTU.W	R1
	MOV.B	@(-3,ER6),R2L
	PUSH.W	R1
	PUSH.W	R2
	JSR	@__b_shift_sl
	ADDS.L	#H'00000002,ER7
	POP.W	R2
	MOV.B	R2L,@(-3,ER6)
;                                        SPI.c(317)
	XOR.W	R1,R1
	MOV.W	R1,@(-2,ER6)
	BRA	?00012:8
?00011:
	MOV.W	@(-2,ER6),R0
	INC.W	#H'0001,R0
	MOV.W	R0,@(-2,ER6)
?00012:
	MOV.W	@(-2,ER6),R0
	CMP.W	#H'000A,R0
	BGE	?00013:8
	BRA	?00011:8
?00013:
;                                        SPI.c(320)
	MOV.B	@(-3,ER6),R0L
	EXTU.W	R0
	MOV.L	@(-8,ER6),ER1
	MOV.B	@ER1,R2L
	EXTU.W	R2
	AND.W	R0,R2
	OR.W	R2,R2
	BEQ	?00014:8
;                                        SPI.c(320)
	MOV.W	#H'0001,R0
	MOV.W	R0,@(-10,ER6)
	BRA	?00015:8
?00014:
;                                        SPI.c(321)
	XOR.W	R0,R0
	MOV.W	R0,@(-10,ER6)
?00015:
;                                        SPI.c(324)
	MOV.B	@_SPI_CSBits,R0L
	EXTU.W	R0
	NOT.W	R0
	MOV.L	@_pSPI_CSPort,ER1
	MOV.B	@ER1,R2L
	AND.B	R0L,R2L
	MOV.B	R2L,@ER1
;                                        SPI.c(326)
	MOV.W	@(-10,ER6),R0
;                                        SPI.c(327)
_EE93_IsReady_end:

	MOV.L	ER6,ER7
	POP.L	ER6
	RTS

	segment	TEXT ATR_CODE
public	_EE93_WriteEnable
_EE93_WriteEnable:
;	flgEnable	8(er6)
;	nAddressBits	10(er6)
;	Cmd	-6(er6)
	PUSH.L	ER6
	MOV.L	ER7,ER6
	SUB.L	#6,ER7
                          
;                                        SPI.c(343)
	MOV.B	#H'4C,R0L
	MOV.B	R0L,@(-6,ER6)
	XOR.B	R0L,R0L
	MOV.B	R0L,@(-5,ER6)
	XOR.B	R0L,R0L
	MOV.B	R0L,@(-4,ER6)
	XOR.B	R0L,R0L
	MOV.B	R0L,@(-3,ER6)
	XOR.B	R0L,R0L
	MOV.B	R0L,@(-2,ER6)
;                                        SPI.c(345)
	MOV.W	@(+8,ER6),R0
	OR.W	R0,R0
	BNE	?00016:8
;                                        SPI.c(345)
	MOV.L	ER6,ER0
	ADD.L	#H'FFFFFFFA,ER0
	MOV.B	#H'40,R1L
	MOV.B	R1L,@ER0
?00016:
;                                        SPI.c(347)
	MOV.W	@(+10,ER6),R0
	PUSH.W	R0
	MOV.L	ER6,ER1
	ADD.L	#H'FFFFFFFA,ER1
	PUSH.L	ER1
	JSR	@_EE93_SendCmd
	ADDS.L	#H'00000002,ER7
	ADDS.L	#H'00000004,ER7
;                                        SPI.c(348)
_EE93_WriteEnable_end:

	MOV.L	ER6,ER7
	POP.L	ER6
	RTS

	segment	TEXT ATR_CODE
public	_EE93_EraseAll
_EE93_EraseAll:
;	nAddressBits	8(er6)
;	Cmd	-6(er6)
	PUSH.L	ER6
	MOV.L	ER7,ER6
	SUB.L	#6,ER7
                          
;                                        SPI.c(361)
	MOV.B	#H'48,R0L
	MOV.B	R0L,@(-6,ER6)
	XOR.B	R0L,R0L
	MOV.B	R0L,@(-5,ER6)
	XOR.B	R0L,R0L
	MOV.B	R0L,@(-4,ER6)
	XOR.B	R0L,R0L
	MOV.B	R0L,@(-3,ER6)
	XOR.B	R0L,R0L
	MOV.B	R0L,@(-2,ER6)
;                                        SPI.c(363)
	MOV.W	@(+8,ER6),R0
	PUSH.W	R0
	MOV.L	ER6,ER1
	ADD.L	#H'FFFFFFFA,ER1
	PUSH.L	ER1
	JSR	@_EE93_SendCmd
	ADDS.L	#H'00000002,ER7
	ADDS.L	#H'00000004,ER7
;                                        SPI.c(364)
_EE93_EraseAll_end:

	MOV.L	ER6,ER7
	POP.L	ER6
	RTS

	segment	TEXT ATR_CODE
public	_EE93_WriteAll
_EE93_WriteAll:
;	Data	8(er6)
;	nAddressBits	10(er6)
;	CmdData	-6(er6)
	PUSH.L	ER6
	MOV.L	ER7,ER6
	SUB.L	#6,ER7
                          
;                                        SPI.c(378)
	MOV.B	#H'44,R0L
	MOV.B	R0L,@(-6,ER6)
	XOR.B	R0L,R0L
	MOV.B	R0L,@(-5,ER6)
	XOR.B	R0L,R0L
	MOV.B	R0L,@(-4,ER6)
	XOR.B	R0L,R0L
	MOV.B	R0L,@(-3,ER6)
	XOR.B	R0L,R0L
	MOV.B	R0L,@(-2,ER6)
;                                        SPI.c(381)
	MOV.L	@_pSPI_CSPort,ER0
	MOV.B	@ER0,R1L
	MOV.B	@_SPI_CSBits,R2L
	OR.B	R2L,R1L
	MOV.B	R1L,@ER0
;                                        SPI.c(383)
	XOR.W	R0,R0
	PUSH.W	R0
	MOV.W	@(+10,ER6),R1
	ADDS.L	#H'00000004,ER1
	PUSH.W	R1
	MOV.L	ER6,ER1
	ADD.L	#H'FFFFFFFA,ER1
	PUSH.L	ER1
	JSR	@_SPI_Write
	ADDS.L	#H'00000004,ER7
	ADDS.L	#H'00000004,ER7
;                                        SPI.c(384)
	XOR.W	R0,R0
	PUSH.W	R0
	MOV.W	#H'0010,R1
	PUSH.W	R1
	MOV.L	ER6,ER2
	ADD.L	#H'00000008,ER2
	PUSH.L	ER2
	JSR	@_SPI_Write
	ADDS.L	#H'00000004,ER7
	ADDS.L	#H'00000004,ER7
;                                        SPI.c(387)
	MOV.B	@_SPI_CSBits,R0L
	EXTU.W	R0
	NOT.W	R0
	MOV.L	@_pSPI_CSPort,ER1
	MOV.B	@ER1,R2L
	AND.B	R0L,R2L
	MOV.B	R2L,@ER1
;                                        SPI.c(388)
_EE93_WriteAll_end:

	MOV.L	ER6,ER7
	POP.L	ER6
	RTS

	segment	TEXT ATR_CODE
public	_EE93_Write
_EE93_Write:
;	Address	8(er6)
;	pData	12(er6)
;	nDataWords	16(er6)
;	nAddressBits	18(er6)
;	nDataBits	-2(er6)
;	Cmd	-3(er6)
	PUSH.L	ER6
	MOV.L	ER7,ER6
	SUBS	#4,ER7
                           
;                                        SPI.c(407)
	MOV.B	#H'50,R0L
	MOV.B	R0L,@(-3,ER6)
;                                        SPI.c(409)
	MOV.W	@(+16,ER6),R0
	SHLL.W	R0
	SHLL.W	R0
	SHLL.W	R0
	SHLL.W	R0
	MOV.W	R0,@(-2,ER6)
;                                        SPI.c(410)
	MOV.W	#H'0020,R1
	MOV.W	@(+18,ER6),R2
	SUB.W	R2,R1
	MOV.L	@(+8,ER6),ER3
	PUSH.W	R1
	PUSH.L	ER3
	JSR	@__l_shift_sl
	ADDS.L	#H'00000002,ER7
	POP.L	ER3
	MOV.L	ER3,@(+8,ER6)
;                                        SPI.c(413)
	MOV.L	@_pSPI_CSPort,ER1
	MOV.B	@ER1,R4L
	MOV.B	@_SPI_CSBits,R0L
	OR.B	R0L,R4L
	MOV.B	R4L,@ER1
;                                        SPI.c(419)
	XOR.W	R0,R0
	PUSH.W	R0
	MOV.W	#H'0004,R1
	PUSH.W	R1
	MOV.L	ER6,ER2
	ADD.L	#H'FFFFFFFD,ER2
	PUSH.L	ER2
	JSR	@_SPI_Write
	ADDS.L	#H'00000004,ER7
	ADDS.L	#H'00000004,ER7
;                                        SPI.c(420)
	XOR.W	R0,R0
	PUSH.W	R0
	MOV.W	@(+18,ER6),R1
	PUSH.W	R1
	MOV.L	ER6,ER2
	ADD.L	#H'00000008,ER2
	PUSH.L	ER2
	JSR	@_SPI_Write
	ADDS.L	#H'00000004,ER7
	ADDS.L	#H'00000004,ER7
;                                        SPI.c(421)
	XOR.W	R0,R0
	PUSH.W	R0
	MOV.W	@(-2,ER6),R1
	PUSH.W	R1
	MOV.L	@(+12,ER6),ER2
	PUSH.L	ER2
	JSR	@_SPI_Write
	ADDS.L	#H'00000004,ER7
	ADDS.L	#H'00000004,ER7
;                                        SPI.c(424)
	MOV.B	@_SPI_CSBits,R0L
	EXTU.W	R0
	NOT.W	R0
	MOV.L	@_pSPI_CSPort,ER1
	MOV.B	@ER1,R2L
	AND.B	R0L,R2L
	MOV.B	R2L,@ER1
;                                        SPI.c(425)
_EE93_Write_end:

	MOV.L	ER6,ER7
	POP.L	ER6
	RTS

	segment	TEXT ATR_CODE
public	_EE93_Read
_EE93_Read:
;	Address	8(er6)
;	pData	12(er6)
;	nDataWords	16(er6)
;	nAddressBits	18(er6)
;	nDataBits	-2(er6)
;	Cmd	-3(er6)
;	bTmp	-4(er6)
	PUSH.L	ER6
	MOV.L	ER7,ER6
	SUBS	#4,ER7
                           
;                                        SPI.c(444)
	MOV.B	#H'60,R0L
	MOV.B	R0L,@(-3,ER6)
;                                        SPI.c(447)
	MOV.W	@(+16,ER6),R0
	SHLL.W	R0
	SHLL.W	R0
	SHLL.W	R0
	SHLL.W	R0
	MOV.W	R0,@(-2,ER6)
;                                        SPI.c(448)
	MOV.W	#H'0020,R1
	MOV.W	@(+18,ER6),R2
	SUB.W	R2,R1
	MOV.L	@(+8,ER6),ER3
	PUSH.W	R1
	PUSH.L	ER3
	JSR	@__l_shift_sl
	ADDS.L	#H'00000002,ER7
	POP.L	ER3
	MOV.L	ER3,@(+8,ER6)
;                                        SPI.c(451)
	MOV.L	@_pSPI_CSPort,ER1
	MOV.B	@ER1,R4L
	MOV.B	@_SPI_CSBits,R0L
	OR.B	R0L,R4L
	MOV.B	R4L,@ER1
;                                        SPI.c(453)
	XOR.W	R0,R0
	PUSH.W	R0
	MOV.W	#H'0004,R1
	PUSH.W	R1
	MOV.L	ER6,ER2
	ADD.L	#H'FFFFFFFD,ER2
	PUSH.L	ER2
	JSR	@_SPI_Write
	ADDS.L	#H'00000004,ER7
	ADDS.L	#H'00000004,ER7
;                                        SPI.c(454)
	XOR.W	R0,R0
	PUSH.W	R0
	MOV.W	@(+18,ER6),R1
	PUSH.W	R1
	MOV.L	ER6,ER2
	ADD.L	#H'00000008,ER2
	PUSH.L	ER2
	JSR	@_SPI_Write
	ADDS.L	#H'00000004,ER7
	ADDS.L	#H'00000004,ER7
;                                        SPI.c(455)
	MOV.W	#H'0001,R0
	PUSH.W	R0
	MOV.W	@(-2,ER6),R1
	PUSH.W	R1
	MOV.L	@(+12,ER6),ER2
	PUSH.L	ER2
	JSR	@_SPI_Read
	ADDS.L	#H'00000004,ER7
	ADDS.L	#H'00000004,ER7
;                                        SPI.c(458)
	MOV.B	@_SPI_CSBits,R0L
	EXTU.W	R0
	NOT.W	R0
	MOV.L	@_pSPI_CSPort,ER1
	MOV.B	@ER1,R2L
	AND.B	R0L,R2L
	MOV.B	R2L,@ER1
;                                        SPI.c(459)
_EE93_Read_end:

	MOV.L	ER6,ER7
	POP.L	ER6
	RTS

	segment	TEXT ATR_CODE
public	_SPI_Write
_SPI_Write:
;	pWrite	8(er6)
;	nWriteBits	12(er6)
;	Mode	15(er6)
	PUSH.L	ER6
	MOV.L	ER7,ER6
                                         
;                                        SPI.c(491)
 DEFINE CLK_BIT R5H ;CLKɑΉrbgԍi[郌WX^
;                                        SPI.c(492)
 DEFINE DO_BIT  R5L ;DOɑΉrbgԍi[郌WX^
;                                        SPI.c(493)
 DEFINE DI_BIT  R3H ;DIɑΉrbgԍi[郌WX^
;                                        SPI.c(494)
 CPHA   EQU 0 ;[h̃NbNʑrbg
;                                        SPI.c(495)
 CPOL   EQU 1 ;[h̃NbNɐrbg
;                                        SPI.c(496)
 DORD   EQU 2 ;[h̃f[^I[_[rbg(0:MSB, 1:LSB)
;                                        SPI.c(499)
 MACRO REVERSE_CLK_BIT() LOCAL(Local1,Local2)
;                                        SPI.c(500)
   BTST  CLK_BIT,R0H
;                                        SPI.c(501)
   BNE   @(Local1:8,PC)
;                                        SPI.c(502)
   BSET  CLK_BIT,R0H
;                                        SPI.c(503)
   BRA   @(Local2:8,PC)
;                                        SPI.c(504)
 Local1:
;                                        SPI.c(505)
   BCLR  CLK_BIT,R0H
;                                        SPI.c(506)
 Local2:
;                                        SPI.c(507)
 ENDM
;                                        SPI.c(510)
 MACRO WAIT() LOCAL(Local1,Local2)
;                                        SPI.c(511)
   MOV.W E2,E0
;                                        SPI.c(512)
   BEQ   @(Local2:8,PC)
;                                        SPI.c(513)
 Local1:
;                                        SPI.c(514)
   DEC.W #1,E0
;                                        SPI.c(515)
   BNE   @(Local1:8,PC)
;                                        SPI.c(516)
 Local2:
;                                        SPI.c(517)
 ENDM
;                                        SPI.c(520)
   MOV.L @(+8,ER6),ER1           ;ER1pWrite(݃f[^)̒lݒ
;                                        SPI.c(521)
   MOV.B @_SPI_DOBit,R5L       ;R5Lɏo̓rbg̃rbgʒuݒ
;                                        SPI.c(522)
   MOV.B @_SPI_ClkBit,R5H      ;R5HɃNbNrbg̃rbgʒuݒ
;                                        SPI.c(523)
   MOV.B @_SPI_DIBit,R3H       ;R3Hɓ̓rbg̃rbgʒuݒ
;                                        SPI.c(524)
   MOV.L @_SPI_PortAddress,ER4 ;ER4Ɏgp|[gAhXݒ
;                                        SPI.c(525)
   MOV.W @_SPI_Wait,E2         ;E2ɃEFCgݒ
;                                        SPI.c(526)
   MOV.B @(+15,ER6),R2L             ;[hݒR2LɃ[h
;                                        SPI.c(527)
   MOV.B #H'02,R2H             ;R2Hɒ萔ݒ
;                                        SPI.c(528)
   MOV.B @ER4,R0H              ;gp|[gf[^R0HɃ[h
;                                        SPI.c(531)
   BTST  #CPOL,R2L             ;CPOL(CLKɐ)̐ݒ𒲂ׂ
;                                        SPI.c(532)
   BNE   L_SPI_WRITE04:8       ;CPOL=1̏ꍇ
;                                        SPI.c(533)
   BCLR  CLK_BIT,R0H           ;CLKrbg0ɏ
;                                        SPI.c(534)
   BRA   L_SPI_WRITE05:8
;                                        SPI.c(535)
 L_SPI_WRITE04:
;                                        SPI.c(536)
   BSET  CLK_BIT,R0H           ;CLKrbg1ɏ
;                                        SPI.c(537)
 L_SPI_WRITE05:
;                                        SPI.c(538)
   MOV.B R0H,@ER4              ;|[gɏo
;                                        SPI.c(541)
   MOV.W @(+12,ER6),E5        ;E5nWrite(݃rbg)ݒ
;                                        SPI.c(542)
   BEQ   SPI_WRITE_EXIT        ;nWrite=0̏ꍇI
;                                        SPI.c(544)
 L_SPI_WRITE02:
;                                        SPI.c(545)
   MOV.B  #8,R3L               ;R3LɃ[v񐔂ݒ
;                                        SPI.c(546)
   MOV.B  @ER1+,R0L            ;R0Lɏ݃f[^[h
;                                        SPI.c(549)
 L_SPI_WRITE06:
;                                        SPI.c(550)
   BTST  #CPHA,R2L             ;CPHA(CLKʑ)̐ݒ𒲂ׂ
;                                        SPI.c(551)
   BEQ   L_SPI_WRITE03:8       ;CPHA=0̏ꍇŏCLK]Ȃ
;                                        SPI.c(552)
   REVERSE_CLK_BIT()           ;R0H̃NbNrbg𔽓]
;                                        SPI.c(553)
   MOV.B R0H,@ER4              ;|[gɏo
;                                        SPI.c(556)
 L_SPI_WRITE03:
;                                        SPI.c(557)
   BTST   #DORD,R2L            ;f[^I[_[𒲂ׂ
;                                        SPI.c(558)
   BEQ    L_SPI_WRITE08:8      ;0̏ꍇVtg
;                                        SPI.c(559)
   SHLR.B R0L                  ;1̏ꍇEVtg
;                                        SPI.c(560)
   BRA    L_SPI_WRITE09:8      ;
;                                        SPI.c(561)
 L_SPI_WRITE08:
;                                        SPI.c(562)
   SHLL.B R0L                  ;R0L1rbgVtg(MSBC(L[)ɉo)
;                                        SPI.c(565)
 L_SPI_WRITE09:
;                                        SPI.c(566)
   BCS    L_SPI_WRITE00:8      ;C=1̏ꍇ
;                                        SPI.c(567)
   BCLR   DO_BIT,R0H           ;R0H̃f[^rbgʒu0ɐݒ
;                                        SPI.c(568)
   BRA    L_SPI_WRITE01:8      ;
;                                        SPI.c(569)
 L_SPI_WRITE00:
;                                        SPI.c(570)
   NOP                         ;0̂Ƃ1̂ƂŃTCNԂςȂ悤
;                                        SPI.c(571)
   NOP
;                                        SPI.c(572)
   BSET   DO_BIT,R0H           ;R0H̃f[^rbgʒu1ɐݒ
;                                        SPI.c(573)
 L_SPI_WRITE01:
;                                        SPI.c(574)
   MOV.B  R0H,@ER4             ;|[gɏo
;                                        SPI.c(576)
   WAIT()
;                                        SPI.c(577)
   REVERSE_CLK_BIT()           ;R0H̃NbNrbg𔽓]
;                                        SPI.c(578)
   MOV.B  R0H,@ER4             ;|[gɏo
;                                        SPI.c(579)
   WAIT()
;                                        SPI.c(582)
   BTST  #CPHA,R2L             ;CPHA(CLKʑ)̐ݒ𒲂ׂ
;                                        SPI.c(583)
   BNE   L_SPI_WRITE07:8       ;CPHA=1̏ꍇŏCLK]Ȃ
;                                        SPI.c(584)
   REVERSE_CLK_BIT()           ;R0H̃NbNrbg𔽓]
;                                        SPI.c(585)
   MOV.B R0H,@ER4              ;|[gɏo
;                                        SPI.c(587)
 L_SPI_WRITE07:
;                                        SPI.c(588)
   DEC.W  #1,E5                ;]rbg1Z
;                                        SPI.c(589)
   BEQ    SPI_WRITE_EXIT:8     ;ݏI
;                                        SPI.c(590)
   DEC.B  R3L                  ;
;                                        SPI.c(591)
   BEQ    L_SPI_WRITE02        ;Vf[^[h
;                                        SPI.c(592)
   BRA    L_SPI_WRITE06        ;JԂ
;                                        SPI.c(594)
 SPI_WRITE_EXIT:
;                                        SPI.c(595)
_SPI_Write_end:

	POP.L	ER6
	RTS

	segment	TEXT ATR_CODE
public	_SPI_Read
_SPI_Read:
;	pRead	8(er6)
;	nReadBits	12(er6)
;	Mode	15(er6)
	PUSH.L	ER6
	MOV.L	ER7,ER6
                                         
;                                        SPI.c(628)
   MOV.L @(+8,ER6),ER1            ;ER1pWrite(݃f[^)̒lݒ
;                                        SPI.c(629)
   MOV.B @_SPI_DOBit,R5L       ;R5Lɏo̓rbg̃rbgʒuݒ
;                                        SPI.c(630)
   MOV.B @_SPI_ClkBit,R5H      ;R5HɃNbNrbg̃rbgʒuݒ
;                                        SPI.c(631)
   MOV.B @_SPI_DIBit,R3H       ;R3Hɓ̓rbg̃rbgʒuݒ
;                                        SPI.c(632)
   MOV.L @_SPI_PortAddress,ER4 ;ER4Ɏgp|[gAhXݒ
;                                        SPI.c(633)
   MOV.W @_SPI_Wait,E2         ;E2ɃEFCgݒ
;                                        SPI.c(634)
   MOV.B @(+15,ER6),R2L             ;[hݒR2LɃ[h
;                                        SPI.c(635)
   MOV.B #H'02,R2H             ;R2Hɒ萔ݒ
;                                        SPI.c(636)
   MOV.B @ER4,R0H              ;gp|[gf[^R0HɃ[h
;                                        SPI.c(639)
   BTST  #CPOL,R2L             ;CPOL(CLKɐ)̐ݒ𒲂ׂ
;                                        SPI.c(640)
   BNE   L_SPI_READ04:8        ;CPOL=1̏ꍇ
;                                        SPI.c(641)
   BCLR  CLK_BIT,R0H           ;CLKrbg0ɏ
;                                        SPI.c(642)
   BRA   L_SPI_READ05:8
;                                        SPI.c(643)
 L_SPI_READ04:
;                                        SPI.c(644)
   BSET  CLK_BIT,R0H           ;CLKrbg1ɏ
;                                        SPI.c(645)
 L_SPI_READ05:
;                                        SPI.c(646)
   MOV.B R0H,@ER4              ;|[gɏo
;                                        SPI.c(648)
 L_SPI_READ20:
;                                        SPI.c(650)
   MOV.W  @(+12,ER6),E5        ;E5nReadBits(݃rbg)ݒ
;                                        SPI.c(651)
   BEQ    SPI_READ_EXIT        ;nReadBits=0̏ꍇI
;                                        SPI.c(653)
 L_SPI_READ21:
;                                        SPI.c(654)
   MOV.B  #8,R3L               ;R3LɃ[v񐔂ݒ
;                                        SPI.c(655)
   XOR    R0L,R0L              ;f[^i[pWX^NA
;                                        SPI.c(658)
 L_SPI_READ22:
;                                        SPI.c(659)
   BTST  #CPHA,R2L             ;CPHA(CLKʑ)̐ݒ𒲂ׂ
;                                        SPI.c(660)
   BEQ   L_SPI_READ23:8        ;CPHA=0̏ꍇŏCLK]Ȃ
;                                        SPI.c(661)
   REVERSE_CLK_BIT()           ;R0H̃NbNrbg𔽓]
;                                        SPI.c(662)
   MOV.B R0H,@ER4              ;|[gɏo
;                                        SPI.c(665)
 L_SPI_READ23:
;                                        SPI.c(666)
   WAIT()
;                                        SPI.c(667)
   MOV.B  @ER4,R0H             ;|[g
;                                        SPI.c(668)
   REVERSE_CLK_BIT()           ;R0H̃NbNrbg𔽓]
;                                        SPI.c(669)
   MOV.B  R0H,@ER4             ;|[gɏo
;                                        SPI.c(672)
   WAIT()
;                                        SPI.c(673)
   BTST   DI_BIT,R0H           ;DIrbg𒲂ׂ
;                                        SPI.c(674)
   BNE    L_SPI_READ24:8       ;
;                                        SPI.c(675)
   BLD    #0,R2H               ;C(L[)0[h
;                                        SPI.c(676)
   BRA    L_SPI_READ25:8
;                                        SPI.c(677)
 L_SPI_READ24:
;                                        SPI.c(678)
   NOP                         ;0̂Ƃ1̂ƂŃTCNԂςȂ悤ɒ
;                                        SPI.c(679)
   NOP
;                                        SPI.c(680)
   BLD    #1,R2H               ;C1[h
;                                        SPI.c(683)
 L_SPI_READ25:
;                                        SPI.c(684)
   BTST   #DORD,R2L            ;f[^I[_[𒲂ׂ
;                                        SPI.c(685)
   BEQ    L_SPI_READ26:8       ;0̏ꍇVtg
;                                        SPI.c(686)
   ROTXR.B R0L                 ;1̏ꍇE[e[g(CMSBɃ[h)
;                                        SPI.c(687)
   BRA    L_SPI_READ27:8       ;
;                                        SPI.c(688)
 L_SPI_READ26:
;                                        SPI.c(689)
   ROTXL.B R0L                 ;R0L[e[g(CLSBɃ[h)
;                                        SPI.c(692)
 L_SPI_READ27:
;                                        SPI.c(693)
   BTST  #CPHA,R2L             ;CPHA(CLKʑ)̐ݒ𒲂ׂ
;                                        SPI.c(694)
   BNE   L_SPI_READ28:8        ;CPHA=1̏ꍇŏCLK]Ȃ
;                                        SPI.c(695)
   REVERSE_CLK_BIT()           ;R0H̃NbNrbg𔽓]
;                                        SPI.c(696)
   MOV.B R0H,@ER4              ;|[gɏo
;                                        SPI.c(698)
 L_SPI_READ28:
;                                        SPI.c(699)
   DEC.W  #1,E5                ;]rbg1Z
;                                        SPI.c(700)
   BEQ    L_SPI_READ30:8       ;ǂݏoI
;                                        SPI.c(701)
   DEC.B  R3L                  ;
;                                        SPI.c(702)
   BEQ    L_SPI_READ29:8       ;
;                                        SPI.c(703)
   BRA    L_SPI_READ22         ;JԂ
;                                        SPI.c(704)
 L_SPI_READ29:
;                                        SPI.c(705)
   MOV.B  R0L,@ER1             ;pReadʒuɓ]
;                                        SPI.c(706)
   INC.L  #1,ER1               ;i[AhXCNg
;                                        SPI.c(707)
   BRA    L_SPI_READ21:8       ;JԂ(̃oCg)
;                                        SPI.c(709)
 L_SPI_READ30:
;                                        SPI.c(710)
   DEC.B  R3L                  ;8rbgE܂œǂݏo`FbN
;                                        SPI.c(711)
   BEQ    L_SPI_READ33:8       ;ǂݏoĂΔ
;                                        SPI.c(713)
 L_SPI_READ31:
;                                        SPI.c(714)
   BTST   #DORD,R2L            ;f[^I[_[𒲂ׂ
;                                        SPI.c(715)
   BEQ    L_SPI_READ32:8       ;0̏ꍇVtg
;                                        SPI.c(716)
   SHLR.B R0L                  ;1̏ꍇEVtg
;                                        SPI.c(717)
   BRA    L_SPI_READ30         ;
;                                        SPI.c(718)
 L_SPI_READ32:
;                                        SPI.c(719)
   SHLL.B R0L                  ;Vtg
;                                        SPI.c(720)
   BRA    L_SPI_READ30
;                                        SPI.c(722)
 L_SPI_READ33:
;                                        SPI.c(723)
   MOV.B  R0L,@ER1             ;Ō̃f[^pReadʒuɓ]
;                                        SPI.c(726)
 SPI_READ_EXIT:
;                                        SPI.c(727)
_SPI_Read_end:

	POP.L	ER6
	RTS

extern __l_shift_sl
extern __b_shift_sl
;
public _pSPI_CSPort
public _SPI_CSBits
;

	segment	DATA ATR_DATA
_SPI_Wait:	DC.W	$0000
_SPI_PortAddress:	DC.L	$00FFFFD3
_SPI_ClkBit:	DC.B	$00
_SPI_DOBit:	DC.B	$01
_SPI_DIBit:	DC.B	$02
	EVEN
_pSPI_CSPort:	DC.L	$00FFFFD3
_SPI_CSBits:	DC.B	$08

	end
