/*****************************************************************************
  SPIpCu
  
  H8/3069pSPIpCułB|[ggpSPĨ}X^s܂
  SPIMicrowireC^tF[XEEPROMp֐܂ł܂B
  
  EЂ͖{vOA܂́ẢϕɊ֘AĐQɊւĈ؂̐
    C𕉂܂B
    
  Copyright (C) eNmEF[u 2007
*****************************************************************************/
#include"spi.h"

static WORD SPI_Wait = 0; //EFCg̐ݒ(1EFCg480nsTCNLт)
static DWORD SPI_PortAddress = 0xffffd3; //P4
static BYTE SPI_ClkBit = 0;
static BYTE SPI_DOBit = 1;
static BYTE SPI_DIBit = 2;
volatile BYTE *pSPI_CSPort = (BYTE*)0xffffd3; //P4
BYTE SPI_CSBits = 0x08;  //CSƂĎgprbg(I)

/*****************************************************************************
  void SPI_WriteRead(void *pWrite, WORD nWriteBits,
                     void *pRead, WORD nReadBits, BYTE Mode)
  
  pWrite     : [in]݃f[^
  nWriteBits : ݃rbg
  pRead      : [out]ǂݏof[^̊i[
  nReadBits  : ǂݏorbg
  Mode       : 샂[h
               rbg0 ǏoNbNʑ(CPHA)
               rbg1 ݎNbNʑ(CPHA)
               rbg2 NbNɐ(CPOL)
               rbg3 f[^I[_[(0:MSB]A1:LSB])
               rbg4 CSɐ(0:"Lo"ANeBuA1:"Hi"ANeBu)
  
  SPIC^tF[Xɏ݂sȂAǂݏosȂ܂BANZX̑O
  CSΉrbgANeBuɂAANZXɃCANeBuɂ܂BANZX
  CS̃xModẽrbg4Ō܂܂B
  
  ]rbg8Ŋ؂ȂꍇAMSB]ꍇMSBɁALSB]
  ꍇɂLSBɃf[^l߂ĂB
  
  NbNʑ͏ݎƓǏoɕʁX̐ݒ肪\łBႦ93C46̂悤
  ȃfoCXɃANZXꍇAݎ̃NbNʑrbg0AǏõN
  bNʑrbg1Ƃ܂B̏ꍇAݎɂ̓X[uNbN̗
  Ńf[^TvOAǏoɂ̓}X^NbN̗Ńf[^
  TvO܂B
*****************************************************************************/
void SPI_WriteRead(void *pWrite, WORD nWriteBits, void *pRead, WORD nReadBits, BYTE Mode)
{
  //CSMANeBuɂ
  if(Mode & 0x10) *pSPI_CSPort |= SPI_CSBits;
  else *pSPI_CSPort &= ~SPI_CSBits;
  
  SPI_Write(pWrite, nWriteBits, Mode >> 1);
  SPI_Read(pRead, nReadBits, ((Mode >> 1) & 0xfe) | (Mode & 0x01));
  
  //CSMCANeBuɂ
  if(Mode & 0x10) *pSPI_CSPort &= ~SPI_CSBits;
  else *pSPI_CSPort |= SPI_CSBits;
}


/*****************************************************************************
  void SPI_SetPort(DWORD Port, int CLKBit, int DOBit, int DIBit, 
                   DWORD CSPort, BYTE CSBits)
  
  Port   : CLK,DO,DI[qƂĎgp|[gAhX
  CLKBit : CLKɎgprbgԍ(0`7)
  DOBit  : DOɎgprbgԍ(0`7)
  DIBit  : DIɎgprbgԍ(0`7)
  CSPort : CSɎgp|[gAhX
  CSBits : CSɎgprbg(rbg}bvŎw)
  
  SPIC^tF[XɎgp|[gw肵܂BCSɎgp|[g͑̃rb
  gƕʂɎwł܂BCSBitŝݔԍł͂Ȃrbg}bvŎw肷邱Ƃɒ
  ĂBႦ΃rbg7gpꍇ̐ݒl0x80łBCSBits͕w
  \ł̂ŕfoCXւ݂̓Ȃǂ\łiǂݏo͓ɂ
  ł܂jBANZXOCS̑ȂꍇACSPort,CSBitsƂ0ƂĂ
  B
*****************************************************************************/
void SPI_SetPort(DWORD Port, int CLKBit, int DOBit, int DIBit, DWORD CSPort, BYTE CSBits)
{
  if(CSPort == 0){
    CSPort = Port;
    CSBits = 0;
  }
  SPI_PortAddress = Port;
  SPI_ClkBit = (BYTE)CLKBit;
  SPI_DOBit = (BYTE)DOBit;
  SPI_DIBit = (BYTE)DIBit;
  pSPI_CSPort = (BYTE*)CSPort;
  SPI_CSBits = CSBits;
}


/*****************************************************************************
  void SPI_SetWait(BYTE Mode, WORD Wait)
  
  Wait : EFCgp[^
  
  EFCgݒ肵܂BEFCgp[^1閈ɖ480nsNbNTC
  NLт܂B
*****************************************************************************/
void SPI_SetWait(WORD Wait)
{
  SPI_Wait = Wait;
}


/*****************************************************************************
  BYTE EE25_ReadStatus()
  
  ߂l : ǂݏoXe[^X

  SPIC^tF[X̃VAEEPROMp֐łBXe[^Xǂݏo܂B
*****************************************************************************/
BYTE EE25_ReadStatus()
{
  BYTE bCmd = 0x05;
  BYTE bStatus;
  
  //CSMANeBuɂ
  *pSPI_CSPort &= ~SPI_CSBits;

  SPI_Write(&bCmd, 8, 0x00);
  SPI_Read(&bStatus, 8, 0x00);
  
  //CSMCANeBuɂ
  *pSPI_CSPort |= SPI_CSBits;
  
  return bStatus;
}


/*****************************************************************************
  void EE25_WriteStatus(BYTE Status)
  
  Status : ރXe[^Xl
  
  SPIC^tF[X̃VAEEPROMp֐łBXe[^X݂܂B
*****************************************************************************/
void EE25_WriteStatus(BYTE Status)
{
  BYTE bData[2] = { 0x01, 0x00 };

  bData[1] = Status;
  
  //CSMANeBuɂ
  *pSPI_CSPort &= ~SPI_CSBits;
  
  SPI_Write(bData, 16, 0x00);
  
  //CSMCANeBuɂ
  *pSPI_CSPort |= SPI_CSBits;
}


/*****************************************************************************
  void EE25_WriteEnable(BOOL flgEnable)
  
  flgEnalbe : ݋/֎~
              TRUE  ݂܂B
              FALSE ݋֎~܂B
  
  SPIC^tF[X̃VAEEPROMp֐łB݂̋^֎~R}h
  ܂B
*****************************************************************************/
void EE25_WriteEnable(BOOL flgEnable)
{
  BYTE bCmd = 0x06;
  if(flgEnable) bCmd = 0x06;
  else bCmd = 0x04;
  
  //CSMANeBuɂ
  *pSPI_CSPort &= ~SPI_CSBits;
  
  SPI_Write(&bCmd, 8, 0x00);
  
  //CSMCANeBuɂ
  *pSPI_CSPort |= SPI_CSBits;
}


/*****************************************************************************
  void EE25_Write(DWORD Address, void *pData, WORD nWrite, int nAddressBits)
  
  Address      : EEPROM̃AhX
  pData        : [in]݃f[^
  nWrite       : ݃oCg
  nAddressBits : EEPROM̃AhX̃rbg(8-32)

  SPIC^tF[X̃VAEEPROMp֐łB݂s܂B݂̓o
  CgPʂōs܂B
  EEPROMɃy[WCg@\ꍇ́Af[^xɏ߂܂B
*****************************************************************************/
void EE25_Write(DWORD Address, void *pData, WORD nWrite, int nAddressBits)
{
  BYTE bCmd;
  BYTE bStatus;
  short nWriteBits;
  
  bCmd = 0x02; //݃R}h
  nWrite <<= 3;   //oCgrbg
  
  //AhX̃rbg9̏ꍇAR}h3rbgʒuA8rbg
  if(nAddressBits == 9){
    if(Address & 0x0100) bCmd |= 0x08;
    nAddressBits = 8;
  }
  nAddressBits = (nAddressBits + 7) & ~0x07; //AhXrbg8rbgPʂɏC
  Address <<= (32 - nAddressBits); //AhXlɂ
  
  //CSMANeBuɂ
  *pSPI_CSPort &= ~SPI_CSBits;
  
  SPI_Write(&bCmd, 8, 0x00);               //R}h𑗐M
  SPI_Write(&Address, nAddressBits, 0x00); //AhX𑗐M
  SPI_Write(pData, nWrite, 0x00);          //f[^𑗐M
  
  //CSMCANeBuɂ
  *pSPI_CSPort |= SPI_CSBits;
}


/*****************************************************************************
  void EE25_Read(DWORD Address, void *pData, WORD nWrite, int nAddressBits)
  
  Address      : EEPROM̃AhX
  pData        : [out]ǂݏof[^̊i[
  nRead        : ǂݏooCg
  nAddressBits : EEPROM̃AhX̃rbg(8-32)

  SPIC^tF[X̃VAEEPROMp֐łBǂݏosȂ܂BǏo
  oCgPʂōs܂B
  EEPROMɃV[PV[h@\ꍇ͕f[^xɓǂ߂܂B
*****************************************************************************/
void EE25_Read(DWORD Address, void *pData, WORD nRead, int nAddressBits)
{
  BYTE bCmd;
  BYTE bStatus;
  WORD wTmp;
  short nWriteBits;
  
  bCmd = 0x03; //ǏoR}h
  nRead <<= 3; //oCgrbg

  //AhX̃rbg9̏ꍇAR}h3rbgʒuA8rbg
  if(nAddressBits == 9){
    if(Address & 0x0100) bCmd |= 0x08;
    nAddressBits = 8;
  }
  
  nAddressBits = (nAddressBits + 7) & ~0x07; //AhXrbg8rbgPʂɏC
  Address <<= (32 - nAddressBits); //AhXlɂ
  
  //CSMANeBuɂ
  *pSPI_CSPort &= ~SPI_CSBits;
  
  SPI_Write(&bCmd, 8, 0x00); //R}h𑗐M
  SPI_Write(&Address, nAddressBits, 0x00); //AhX𑗐M
  SPI_Read(pData, nRead, 0x00); //f[^M
  
  //CSMCANeBuɂ
  *pSPI_CSPort |= SPI_CSBits;
}


/*****************************************************************************
  static void EE93_SendCmd(BYTE *pCmd, int nAddressBits)
  
  pCmd         : MR}h
  nAddressBits : AhX̃rbg

  MicrowireC^tF[X̃VAEEPROMp֐łBR}h𑗐M܂B
*****************************************************************************/
static void EE93_SendCmd(BYTE *pCmd, int nAddressBits)
{
  //CSMANeBuɂ
  *pSPI_CSPort |= SPI_CSBits;

  //[J[ɂĂ̓X^[gRfBV"01"2rbgv̂
  //̂Ő擪0}R}h4rbgőBX^[grbg1rbg̐
  //i͐擪1rbg𖳎Ď"1"ŃX^[grbgƂē삷̂Ō݊
  //B
  SPI_Write(pCmd, nAddressBits + 4, 0x00); //R}hƃAhX𑗐M
  
  //CSMCANeBuɂ
  *pSPI_CSPort &= ~SPI_CSBits;
}


/*****************************************************************************
  BOOL EE93_IsReady()
  
  ߂l : `bṽANZX
           TRUE  ANZX\
           FALSE /쒆BANZXs
           
  MicrowireC^tF[X̃VAEEPROMp֐łB݁A܂́A
  Iׂ܂B
*****************************************************************************/
BOOL EE93_IsReady()
{
  int i;
  BYTE TestBit = 0x01;
  volatile BYTE *pPort;
  BOOL ret;
  
  //CSMANeBuɂ
  *pSPI_CSPort |= SPI_CSBits;
  
  pPort = (volatile BYTE*)SPI_PortAddress;
  TestBit <<= SPI_DIBit;
  
  for(i=0;i<10;i++); //Xe[^XLɂȂ̂҂
  
  //Xe[^X̓Ǐo
  if(*pPort & TestBit) ret = TRUE;
  else ret = FALSE;
  
  //CSMCANeBuɂ
  *pSPI_CSPort &= ~SPI_CSBits;
  
  return ret;
}


/*****************************************************************************
  void EE93_WriteEnable(BOOL flgEnable, int nAddressBits)

  flgEnable    : ݋/֎~
                 TRUE  ݋
                 FALSE ݋֎~
  nAddressBits : AhXrbg
              
  MicrowireC^tF[X̃VAEEPROMp֐łB݂܂͋֎~R
  }h𑗐M܂B
*****************************************************************************/
void EE93_WriteEnable(BOOL flgEnable, int nAddressBits)
{
  BYTE Cmd[5] = { 0x4c, 0x00, 0x00, 0x00, 0x00 };
  
  if(!flgEnable) Cmd[0] = 0x40;
  
  EE93_SendCmd(Cmd, nAddressBits);
}


/*****************************************************************************
  void EE93_EraseAll(int nAddressBits)
  
  nAddressBits : AhX̃rbg
  
  MicrowireC^tF[X̃VAEEPROMp֐łBSẴ̈
  ܂B
*****************************************************************************/
void EE93_EraseAll(int nAddressBits)
{
  BYTE Cmd[5] = { 0x48, 0x00, 0x00, 0x00, 0x00 };

  EE93_SendCmd(Cmd, nAddressBits);
}


/*****************************************************************************
  void EE93_WriteAll(WORD Data, int nAddressBits)
  
  Data         : ރf[^(16rbgl)
  nAddressBits : AhX̃rbg

  MicrowireC^tF[X̃VAEEPROMp֐łBSẴ̈ɓl
  ݂܂B
*****************************************************************************/
void EE93_WriteAll(WORD Data, int nAddressBits)
{
  BYTE CmdData[5] = { 0x44, 0x00, 0x00, 0x00, 0x00 };
  
  //CSMANeBuɂ
  *pSPI_CSPort |= SPI_CSBits;
  
  SPI_Write(CmdData, nAddressBits + 4, 0x00); //R}hƃAhX𑗐M
  SPI_Write(&Data, 16, 0x00); //f[^𑗐M
  
  //CSMCANeBuɂ
  *pSPI_CSPort &= ~SPI_CSBits;
}


/*****************************************************************************
  void EE93_Write(DWORD Address, void *pData,
                  WORD nDataWords, int nAddressBits)
  
  Address      : ݂sȂAhX
  pData        : [in]ރf[^
  nDataWords   : ރf[^([hP)
  nAddressBits : AhX̃rbg

  MicrowireC^tF[X̃VAEEPROMp֐łBf[^݂܂B
  ݂16rbgPʂōs܂̂ŒӂĂB
  EEPROMɃy[WCg@\ꍇ́Af[^xɏ߂܂B
*****************************************************************************/
void EE93_Write(DWORD Address, void *pData, WORD nDataWords, int nAddressBits)
{
  WORD nDataBits;
  BYTE Cmd = 0x50;
  
  nDataBits = nDataWords << 4;    //f[^̃rbgvZ
  Address <<= (32- nAddressBits); //AhXMSBl߂

  //CSMANeBuɂ
  *pSPI_CSPort |= SPI_CSBits;

  //[J[ɂĂ̓X^[gRfBV"01"2rbgv̂
  //̂Ő擪0}R}h4rbgőBX^[grbg1rbg̐
  //i͐擪1rbg𖳎Ď"1"ŃX^[grbgƂē삷̂Ō݊
  //B
  SPI_Write(&Cmd, 4, 0x00); //R}h𑗐M
  SPI_Write(&Address, nAddressBits, 0x00); //AhX𑗐M
  SPI_Write(pData, nDataBits, 0x00); //f[^𑗐M
  
  //CSMCANeBuɂ
  *pSPI_CSPort &= ~SPI_CSBits;
}


/*****************************************************************************
  void EE93_Read(DWORD Address, void *pData, 
                 WORD nDataWords, int nAddressBits)
  
  Address      : ǂݏosȂAhX
  pData        : [out]ǂݏof[^̊i[
  nDataWords   : ǂݏof[^([hP)
  nAddressBits : AhX̃rbg

  MicrowireC^tF[X̃VAEEPROMp֐łBf[^ǂݏo܂B
  o16rbgPʂōs܂̂ŒӂĂB
  EEPROMɃV[PV[h@\ꍇ͕f[^xɓǂ߂܂B
*****************************************************************************/
void EE93_Read(DWORD Address, void *pData, WORD nDataWords, int nAddressBits)
{
  WORD nDataBits;
  BYTE Cmd = 0x60;
  BYTE bTmp;
  
  nDataBits = nDataWords << 4;    //f[^̃rbgvZ
  Address <<= (32- nAddressBits); //AhXMSBl߂

  //CSMANeBuɂ
  *pSPI_CSPort |= SPI_CSBits;

  SPI_Write(&Cmd, 4, 0x00); //R}h𑗐M
  SPI_Write(&Address, nAddressBits, 0x00); //AhX𑗐M
  SPI_Read(pData, nDataBits, 0x01); //f[^̓Ǐo(CPHAύX)
  
  //CSMCANeBuɂ
  *pSPI_CSPort &= ~SPI_CSBits;
}


/*****************************************************************************
  void SPI_Write(void *pWrite, WORD nWriteBits, BYTE Mode)
  
  pWrite     : [in]݃f[^
  nWriteBits : ރrbg
  Mode       : 샂[h
               rbg0 NbNʑ(CPHA)
               rbg1 NbNɐ(CPOL)
               rbg2 f[^I[_[(0:MSB]A1:LSB])
               
  SPIC^tF[Xf[^o͂܂BCS(`bvZNg)M͑삳
  Bʓr|[gȂǂŐ䂷Kv܂B
  
  gpWX^
  E5  : ]rbg
  R5H : CLKɎgprbgԍ
  R5L : DOɎgprbgԍ
  ER4 : SPIŎgp|[gAhX
  R3H : DIɎgprbgԍ
  R3L : 8rbgJEg郋[vJE^
  E2  : EFCg̃[v
  R2H : C(L[)ɒlݒ肷ƂɎg萔
  R2L : [hݒ
  ER1 : ]܂͓]AhX
  R0H : |[gf[^(ER4Őݒ肳ꂽ|[g̃f[^)
  R0L : ݁Aǂݏof[^ۑp
*****************************************************************************/
void SPI_Write(void *pWrite, WORD nWriteBits, BYTE Mode)
{
  _asm DEFINE CLK_BIT R5H ;CLKɑΉrbgԍi[郌WX^
  _asm DEFINE DO_BIT  R5L ;DOɑΉrbgԍi[郌WX^
  _asm DEFINE DI_BIT  R3H ;DIɑΉrbgԍi[郌WX^
  _asm CPHA   EQU 0 ;[h̃NbNʑrbg
  _asm CPOL   EQU 1 ;[h̃NbNɐrbg
  _asm DORD   EQU 2 ;[h̃f[^I[_[rbg(0:MSB, 1:LSB)
  
  //R0HWX^CLK_BIT𔽓]}N
  _asm MACRO REVERSE_CLK_BIT() LOCAL(Local1,Local2)
  _asm   BTST  CLK_BIT,R0H
  _asm   BNE   @(Local1:8,PC)
  _asm   BSET  CLK_BIT,R0H
  _asm   BRA   @(Local2:8,PC)
  _asm Local1:
  _asm   BCLR  CLK_BIT,R0H
  _asm Local2:
  _asm ENDM

  //ݒlɏ]ăEFCg}N
  _asm MACRO WAIT() LOCAL(Local1,Local2)
  _asm   MOV.W E2,E0
  _asm   BEQ   @(Local2:8,PC)
  _asm Local1:
  _asm   DEC.W #1,E0
  _asm   BNE   @(Local1:8,PC)
  _asm Local2:
  _asm ENDM

  //p[^WX^ɐݒ肷
  _asm   MOV.L \pWrite,ER1           ;ER1pWrite(݃f[^)̒lݒ
  _asm   MOV.B @_SPI_DOBit,R5L       ;R5Lɏo̓rbg̃rbgʒuݒ
  _asm   MOV.B @_SPI_ClkBit,R5H      ;R5HɃNbNrbg̃rbgʒuݒ
  _asm   MOV.B @_SPI_DIBit,R3H       ;R3Hɓ̓rbg̃rbgʒuݒ
  _asm   MOV.L @_SPI_PortAddress,ER4 ;ER4Ɏgp|[gAhXݒ
  _asm   MOV.W @_SPI_Wait,E2         ;E2ɃEFCgݒ
  _asm   MOV.B \Mode,R2L             ;[hݒR2LɃ[h
  _asm   MOV.B #H'02,R2H             ;R2Hɒ萔ݒ
  _asm   MOV.B @ER4,R0H              ;gp|[gf[^R0HɃ[h
 
  //CPOL𒲂ׂCLKrbgɏlݒ
  _asm   BTST  #CPOL,R2L             ;CPOL(CLKɐ)̐ݒ𒲂ׂ
  _asm   BNE   L_SPI_WRITE04:8       ;CPOL=1̏ꍇ
  _asm   BCLR  CLK_BIT,R0H           ;CLKrbg0ɏ
  _asm   BRA   L_SPI_WRITE05:8
  _asm L_SPI_WRITE04:
  _asm   BSET  CLK_BIT,R0H           ;CLKrbg1ɏ
  _asm L_SPI_WRITE05:
  _asm   MOV.B R0H,@ER4              ;|[gɏo
  
  //ݏ
  _asm   MOV.W \nWriteBits,E5        ;E5nWrite(݃rbg)ݒ
  _asm   BEQ   SPI_WRITE_EXIT        ;nWrite=0̏ꍇI

  _asm L_SPI_WRITE02:
  _asm   MOV.B  #8,R3L               ;R3LɃ[v񐔂ݒ
  _asm   MOV.B  @ER1+,R0L            ;R0Lɏ݃f[^[h

  //CPHA=1̏ꍇŏɃNbN𔽓]
  _asm L_SPI_WRITE06:
  _asm   BTST  #CPHA,R2L             ;CPHA(CLKʑ)̐ݒ𒲂ׂ
  _asm   BEQ   L_SPI_WRITE03:8       ;CPHA=0̏ꍇŏCLK]Ȃ
  _asm   REVERSE_CLK_BIT()           ;R0H̃NbNrbg𔽓]
  _asm   MOV.B R0H,@ER4              ;|[gɏo

  //f[^̃Vtg
  _asm L_SPI_WRITE03:
  _asm   BTST   #DORD,R2L            ;f[^I[_[𒲂ׂ
  _asm   BEQ    L_SPI_WRITE08:8      ;0̏ꍇVtg
  _asm   SHLR.B R0L                  ;1̏ꍇEVtg
  _asm   BRA    L_SPI_WRITE09:8      ;
  _asm L_SPI_WRITE08:
  _asm   SHLL.B R0L                  ;R0L1rbgVtg(MSBC(L[)ɉo)

  //f[^rbg̏o
  _asm L_SPI_WRITE09:
  _asm   BCS    L_SPI_WRITE00:8      ;C=1̏ꍇ
  _asm   BCLR   DO_BIT,R0H           ;R0H̃f[^rbgʒu0ɐݒ
  _asm   BRA    L_SPI_WRITE01:8      ;
  _asm L_SPI_WRITE00:
  _asm   NOP                         ;0̂Ƃ1̂ƂŃTCNԂςȂ悤
  _asm   NOP
  _asm   BSET   DO_BIT,R0H           ;R0H̃f[^rbgʒu1ɐݒ
  _asm L_SPI_WRITE01:
  _asm   MOV.B  R0H,@ER4             ;|[gɏo
  
  _asm   WAIT()
  _asm   REVERSE_CLK_BIT()           ;R0H̃NbNrbg𔽓]
  _asm   MOV.B  R0H,@ER4             ;|[gɏo
  _asm   WAIT()
  
  //CPHA=0̏ꍇNbN𔽓]
  _asm   BTST  #CPHA,R2L             ;CPHA(CLKʑ)̐ݒ𒲂ׂ
  _asm   BNE   L_SPI_WRITE07:8       ;CPHA=1̏ꍇŏCLK]Ȃ
  _asm   REVERSE_CLK_BIT()           ;R0H̃NbNrbg𔽓]
  _asm   MOV.B R0H,@ER4              ;|[gɏo

  _asm L_SPI_WRITE07:
  _asm   DEC.W  #1,E5                ;]rbg1Z
  _asm   BEQ    SPI_WRITE_EXIT:8     ;ݏI
  _asm   DEC.B  R3L                  ;
  _asm   BEQ    L_SPI_WRITE02        ;Vf[^[h
  _asm   BRA    L_SPI_WRITE06        ;JԂ

  _asm SPI_WRITE_EXIT:
}


/*****************************************************************************
  void SPI_Read(void *pRead, WORD nReadBits, BYTE Mode)
  
  pRead     : [out]ǂݏof[^̊i[
  nReadBits : ǂݏorbg
  Mode      : 샂[h
              rbg0 NbNʑ(CPHA)
              rbg1 NbNɐ(CPOL)
              rbg2 f[^I[_[(0:MSB]A1:LSB])
               
  SPIC^tF[Xf[^͂܂BCS(`bvZNg)M͑삳
  Bʓr|[gȂǂŐ䂷Kv܂B

  gpWX^
  E5  : ]rbg
  R5H : CLKɎgprbgԍ
  R5L : DOɎgprbgԍ
  ER4 : SPIŎgp|[gAhX
  R3H : DIɎgprbgԍ
  R3L : 8rbgJEg郋[vJE^
  E2  : EFCg̃[v
  R2H : C(L[)ɒlݒ肷ƂɎg萔
  R2L : [hݒ
  ER1 : ]܂͓]AhX
  R0H : |[gf[^(ER4Őݒ肳ꂽ|[g̃f[^)
  R0L : ݁Aǂݏof[^ۑp
*****************************************************************************/
void SPI_Read(void *pRead, WORD nReadBits, BYTE Mode)
{
  //p[^WX^ɐݒ肷
  _asm   MOV.L \pRead,ER1            ;ER1pWrite(݃f[^)̒lݒ
  _asm   MOV.B @_SPI_DOBit,R5L       ;R5Lɏo̓rbg̃rbgʒuݒ
  _asm   MOV.B @_SPI_ClkBit,R5H      ;R5HɃNbNrbg̃rbgʒuݒ
  _asm   MOV.B @_SPI_DIBit,R3H       ;R3Hɓ̓rbg̃rbgʒuݒ
  _asm   MOV.L @_SPI_PortAddress,ER4 ;ER4Ɏgp|[gAhXݒ
  _asm   MOV.W @_SPI_Wait,E2         ;E2ɃEFCgݒ
  _asm   MOV.B \Mode,R2L             ;[hݒR2LɃ[h
  _asm   MOV.B #H'02,R2H             ;R2Hɒ萔ݒ
  _asm   MOV.B @ER4,R0H              ;gp|[gf[^R0HɃ[h
 
  //CPOL𒲂ׂCLKrbgɏlݒ
  _asm   BTST  #CPOL,R2L             ;CPOL(CLKɐ)̐ݒ𒲂ׂ
  _asm   BNE   L_SPI_READ04:8        ;CPOL=1̏ꍇ
  _asm   BCLR  CLK_BIT,R0H           ;CLKrbg0ɏ
  _asm   BRA   L_SPI_READ05:8
  _asm L_SPI_READ04:
  _asm   BSET  CLK_BIT,R0H           ;CLKrbg1ɏ
  _asm L_SPI_READ05:
  _asm   MOV.B R0H,@ER4              ;|[gɏo
  
  _asm L_SPI_READ20:
  //ǂݏo
  _asm   MOV.W  \nReadBits,E5        ;E5nReadBits(݃rbg)ݒ
  _asm   BEQ    SPI_READ_EXIT        ;nReadBits=0̏ꍇI

  _asm L_SPI_READ21:
  _asm   MOV.B  #8,R3L               ;R3LɃ[v񐔂ݒ
  _asm   XOR    R0L,R0L              ;f[^i[pWX^NA

  //CPHA=1̏ꍇŏɃNbN𔽓]
  _asm L_SPI_READ22:
  _asm   BTST  #CPHA,R2L             ;CPHA(CLKʑ)̐ݒ𒲂ׂ
  _asm   BEQ   L_SPI_READ23:8        ;CPHA=0̏ꍇŏCLK]Ȃ
  _asm   REVERSE_CLK_BIT()           ;R0H̃NbNrbg𔽓]
  _asm   MOV.B R0H,@ER4              ;|[gɏo

  //NbN𔽓]
  _asm L_SPI_READ23:
  _asm   WAIT()
  _asm   MOV.B  @ER4,R0H             ;|[g
  _asm   REVERSE_CLK_BIT()           ;R0H̃NbNrbg𔽓]
  _asm   MOV.B  R0H,@ER4             ;|[gɏo

  //f[^̃VtgƊi[
  _asm   WAIT()
  _asm   BTST   DI_BIT,R0H           ;DIrbg𒲂ׂ
  _asm   BNE    L_SPI_READ24:8       ;
  _asm   BLD    #0,R2H               ;C(L[)0[h
  _asm   BRA    L_SPI_READ25:8
  _asm L_SPI_READ24:
  _asm   NOP                         ;0̂Ƃ1̂ƂŃTCNԂςȂ悤ɒ
  _asm   NOP
  _asm   BLD    #1,R2H               ;C1[h

  //f[^̃Vtg
  _asm L_SPI_READ25:
  _asm   BTST   #DORD,R2L            ;f[^I[_[𒲂ׂ
  _asm   BEQ    L_SPI_READ26:8       ;0̏ꍇVtg
  _asm   ROTXR.B R0L                 ;1̏ꍇE[e[g(CMSBɃ[h)
  _asm   BRA    L_SPI_READ27:8       ;
  _asm L_SPI_READ26:
  _asm   ROTXL.B R0L                 ;R0L[e[g(CLSBɃ[h)

  //CPHA=0̏ꍇNbN𔽓]
  _asm L_SPI_READ27:
  _asm   BTST  #CPHA,R2L             ;CPHA(CLKʑ)̐ݒ𒲂ׂ
  _asm   BNE   L_SPI_READ28:8        ;CPHA=1̏ꍇŏCLK]Ȃ
  _asm   REVERSE_CLK_BIT()           ;R0H̃NbNrbg𔽓]
  _asm   MOV.B R0H,@ER4              ;|[gɏo

  _asm L_SPI_READ28:
  _asm   DEC.W  #1,E5                ;]rbg1Z
  _asm   BEQ    L_SPI_READ30:8       ;ǂݏoI
  _asm   DEC.B  R3L                  ;
  _asm   BEQ    L_SPI_READ29:8       ;
  _asm   BRA    L_SPI_READ22         ;JԂ
  _asm L_SPI_READ29:
  _asm   MOV.B  R0L,@ER1             ;pReadʒuɓ]
  _asm   INC.L  #1,ER1               ;i[AhXCNg
  _asm   BRA    L_SPI_READ21:8       ;JԂ(̃oCg)

  _asm L_SPI_READ30:
  _asm   DEC.B  R3L                  ;8rbgE܂œǂݏo`FbN
  _asm   BEQ    L_SPI_READ33:8       ;ǂݏoĂΔ
  //[̃f[^Vtg
  _asm L_SPI_READ31:
  _asm   BTST   #DORD,R2L            ;f[^I[_[𒲂ׂ
  _asm   BEQ    L_SPI_READ32:8       ;0̏ꍇVtg
  _asm   SHLR.B R0L                  ;1̏ꍇEVtg
  _asm   BRA    L_SPI_READ30         ;
  _asm L_SPI_READ32:
  _asm   SHLL.B R0L                  ;Vtg
  _asm   BRA    L_SPI_READ30
  
  _asm L_SPI_READ33:
  _asm   MOV.B  R0L,@ER1             ;Ō̃f[^pReadʒuɓ]

  //I
  _asm SPI_READ_EXIT:
}


